 
#include "commonParams.txt" 
 
############################################################################### 
## we have the following mixture collections that we will need :
##	1-D :	nc_dummy, nc_P, nc_y, nc_b
##	2-D :	nc_dummy2, nc_yb
## and we want to  use 3 components per dimension for each -- ie three 1-D 
## components, or nine 2-D components

 
DPMF_IN_FILE    inline 
6
  0       gmw_dummy   1   1.0 
  1      gmw_dummy2   1   1.0 
  2           gmw_P   3   0.33   0.34   0.33 
  3           gmw_y   3   0.33   0.34   0.33
  4           gmw_b   3   0.33   0.34   0.33
  5          gmw_yb   9   0.1111 0.1111 0.1111 0.1111 0.1111 0.1111 0.1111 0.1111 0.1111
 
############################################################################### 
## 
## there are certain tables where certain fields *should* be zero, but others 
## where we do not want to "learn" a zero if there are no counts ... so we 
## need to define some Dirichlet tables ... we need a 2x2 and a 2x2x2 ... 
 
DIRICHLET_TAB_IN_FILE        inline 
3                %% number of tables to follow 
 
0                %% index 
squareDirTable   %% name 
2                %% number of dimensions 
2  2             %% cardinality of each dimension 
0  0             %% meta-counts 
1  1 
 
1                %% index 
cubeDirTable     %% name 
3                %% number of dimensions 
2  2  2          %% cardinality of each dimension 
0  0             %% meta-counts 
0  0 
1  1 
1  1 
 
2                %% index 
longDirTable     %% name 
2                %% number of dimensions 
CARD_iPeptIdx 2  %% cardinality of each dimension 
0  0 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
1  1 
 
 
 
############################################################################### 
## 
 
MEAN_IN_FILE    inline 
20
  0      mean_dummy   1   0.500
  1     mean_dummy2   2   0.500  0.500
  2        mean_P_0   1   0.167 
  3        mean_P_1   1   0.500 
  4        mean_P_2   1   0.833 
  5        mean_y_0   1   0.167 
  6        mean_y_1   1   0.500 
  7        mean_y_2   1   0.833 
  8        mean_b_0   1   0.167 
  9        mean_b_1   1   0.500 
 10        mean_b_2   1   0.833 
 11       mean_yb_0   2   0.167  0.167
 12       mean_yb_1   2   0.167  0.500
 13       mean_yb_2   2   0.167  0.833
 14       mean_yb_3   2   0.500  0.167
 15       mean_yb_4   2   0.500  0.500
 16       mean_yb_5   2   0.500  0.833
 17       mean_yb_6   2   0.833  0.167
 18       mean_yb_7   2   0.833  0.500
 19       mean_yb_8   2   0.833  0.833
 
COVAR_IN_FILE    inline 
20
  0      cvar_dummy   1   1.000
  1     cvar_dummy2   2   1.000  1.000
  2        cvar_P_0   1   0.062
  3        cvar_P_1   1   0.062
  4        cvar_P_2   1   0.062
  5        cvar_y_0   1   0.062
  6        cvar_y_1   1   0.062
  7        cvar_y_2   1   0.062
  8        cvar_b_0   1   0.062
  9        cvar_b_1   1   0.062
 10        cvar_b_2   1   0.062
 11       cvar_yb_0   2   0.062  0.062
 12       cvar_yb_1   2   0.062  0.062
 13       cvar_yb_2   2   0.062  0.062
 14       cvar_yb_3   2   0.062  0.062
 15       cvar_yb_4   2   0.062  0.062
 16       cvar_yb_5   2   0.062  0.062
 17       cvar_yb_6   2   0.062  0.062
 18       cvar_yb_7   2   0.062  0.062
 19       cvar_yb_8   2   0.062  0.062

###############################################################################
                                                                                                        
DLINK_IN_FILE   inline
1 % number of dlinks to follow
                                                                                                        
0   % dlink index 0
dlink_str0  % dlink name
2   % number of features
1  0 1
0


% dlink matrices
DLINK_MAT_IN_FILE inline
10 
0 
dlink_dummy2 
dlink_str0 
2 
1 -4.9561044574e-01 
0 
1 
dlink_yb_0 
dlink_str0 
2 
1 -8.4673695266e-02 
0 
2 
dlink_yb_1 
dlink_str0 
2 
1 -1.4857445657e-01 
0 
3 
dlink_yb_2 
dlink_str0 
2 
1 -2.9227334261e-01 
0 
4 
dlink_yb_3 
dlink_str0 
2 
1 -1.7790476978e-01 
0 
5 
dlink_yb_4 
dlink_str0 
2 
1 -1.2637333572e-01 
0 
6 
dlink_yb_5 
dlink_str0 
2 
1 -5.1778793335e-02 
0 
7 
dlink_yb_6 
dlink_str0 
2 
1 -3.8687661290e-02 
0 
8 
dlink_yb_7 
dlink_str0 
2 
1 -3.3950131387e-02 
0 
9 
dlink_yb_8 
dlink_str0 
2 
1 -1.2763371691e-02 
0 

 
## here we define the "mixture components" by grouping a  
## noise and a variance to define a single Gaussian 
## the first number is the index, the second the dimensionality
## and the third is the 'type' of the component (type=0 means
## it uses only a diagonal covariance matrix)
 
MC_IN_FILE    inline  
20
  0   1   0        mc_dummy      mean_dummy      cvar_dummy
  1   2   0       mc_dummy2     mean_dummy2     cvar_dummy2
  2   1   0          mc_P_0        mean_P_0        cvar_P_0 
  3   1   0          mc_P_1        mean_P_1        cvar_P_1 
  4   1   0          mc_P_2        mean_P_2        cvar_P_2 
  5   1   0          mc_y_0        mean_y_0        cvar_y_0 
  6   1   0          mc_y_1        mean_y_1        cvar_y_1 
  7   1   0          mc_y_2        mean_y_2        cvar_y_2 
  8   1   0          mc_b_0        mean_b_0        cvar_b_0 
  9   1   0          mc_b_1        mean_b_1        cvar_b_1 
 10   1   0          mc_b_2        mean_b_2        cvar_b_2 
 11   2   1         mc_yb_0       mean_yb_0       cvar_yb_0 dlink_yb_0
 12   2   1         mc_yb_1       mean_yb_1       cvar_yb_1 dlink_yb_1
 13   2   1         mc_yb_2       mean_yb_2       cvar_yb_2 dlink_yb_2
 14   2   1         mc_yb_3       mean_yb_3       cvar_yb_3 dlink_yb_3
 15   2   1         mc_yb_4       mean_yb_4       cvar_yb_4 dlink_yb_4 
 16   2   1         mc_yb_5       mean_yb_5       cvar_yb_5 dlink_yb_5
 17   2   1         mc_yb_6       mean_yb_6       cvar_yb_6 dlink_yb_6
 18   2   1         mc_yb_7       mean_yb_7       cvar_yb_7 dlink_yb_7
 19   2   1         mc_yb_8       mean_yb_8       cvar_yb_8 dlink_yb_8
  
## next we define the "mixtures" ... 
##   <mx#> <dim> <name> <# of components> <dpmf> <mc0> <mc1> <mc2> ... 
 
MX_IN_FILE    inline  
6
  0   1        mx_dummy   1       gmw_dummy        mc_dummy 
  1   2       mx_dummy2   1      gmw_dummy2       mc_dummy2
  2   1            mx_P   3           gmw_P          mc_P_0  mc_P_1  mc_P_2  
  3   1            mx_y   3           gmw_y          mc_y_0  mc_y_1  mc_y_2  
  4   1            mx_b   3           gmw_b          mc_b_0  mc_b_1  mc_b_2  
  5   2           mx_yb   9          gmw_yb         mc_yb_0 mc_yb_1 mc_yb_2 mc_yb_3 mc_yb_4 mc_yb_5 mc_yb_6 mc_yb_7 mc_yb_8
  
## in this case all of the 'collections' actually only have a
## single name ...
 
NAME_COLLECTION_IN_FILE    inline 
7 
  0     nc_dummy  1    mx_dummy 
  1    nc_dummy2  1   mx_dummy2
  2         nc_P  1        mx_P 
  3         nc_y  1        mx_y 
  4         nc_b  1        mx_b 
  5        nc_yb  1       mx_yb 
  6     nc_unity  1   internal:UnityScore
 
############################################################################### 
## 
## here we define a decision tree which just does a simple 
## 1-to-1 mapping w/o any transformation ... 
## 
 
DT_IN_FILE    inline 
4                        %% number of DTs to follow 
 
0                        %% index 
directMap                %% name 
1                        %% number of parents 
        -1 { p0 }        %% just copies/returns the parent value 
 
## this DT breaks the peptide into five regions which we will 
## refer to in some places by the letters A-E and in other 
## places by the integers 0-4 : 
##        A/0 : first amide bond (starting from the N-term) 
##        B/1 : second amide bond 
##        C/2 : central amide bonds 
##        D/3 : second-to-last amide bond 
##        E/4 : last amide bond 
1                                %% index 
map2Region_DT                    %% name 
2                                %% number of parents 
    0  3  2  3  default          %% split on p0 (leftCounter) : 3 splits 
         -1  0                   %%     if p0=2 return region A/0 
         -1  1                   %%     if p0=3 return region B/1 
          1  3  1  2  default    %%     else split on p1 (rightCounter) : 3 splits 
               -1  4             %%          if p1=1 return region E/4 
               -1  3             %%          if p1=2 return region D/3 
               -1  2             %%          else return region C/2 
 
2                        %% index 
setZero_DT               %% name 
0                        %% number of parents 
    -1   0               %% always return 0  
 
3                        %% index 
two2one                  %% name 
2                        %% number of parents 
    -1 { cp1*p0 + p1 } 
 
 
 
 
############################################################################### 
## 
 
DETERMINISTIC_CPT_IN_FILE        inline 
 
1                                %% total number of Det CPTs to follow 
 
0                                            %% index 
map2Region                                   %% name 
2                                            %% two parents 
CARD_iPeptIdx CARD_iPeptIdx CARD_pepRegion   %% cardinalities (parents then self) 
map2Region_DT                                %% DT name 
 
############################################################################### 
## 
## and now we define the dense CPTs 
## 
 
DENSE_CPT_IN_FILE    inline 
18
 
## this CPT contains the probability of observing the unfragmented peptide 
0 
init_iFragState                %% name 
0                              %% number of parents 
CARD_BINARY                    %% self-cardinality 
0.5  0.5 
 
## these trans?_iFragState CPTs describe the probability of a 
## fragmentation event given the previous fragmentation event 
## (or lack thereof), and further there are 5 of these 
## CPTs, one for each "region" of the peptide/HMM ... 
1 
transA_iFragState               %% name 
1                               %% number of parents 
CARD_BINARY  CARD_BINARY        %% parent- then self-cardinality 
0.5  0.5 
0.5  0.5 
 
 
2 
transB_iFragState               %% name 
1                               %% number of parents 
CARD_BINARY  CARD_BINARY        %% parent- then self-cardinality 
0.5  0.5 
0.5  0.5 
 
 
3 
transC_iFragState               %% name 
1                               %% number of parents 
CARD_BINARY  CARD_BINARY        %% parent- then self-cardinality 
0.5  0.5 
0.5  0.5 
 
 
4 
transD_iFragState                %% name 
1                                %% number of parents 
CARD_BINARY  CARD_BINARY         %% parent- then self-cardinality 
0.5  0.5 
0.5  0.5 
 
 
5 
transE_iFragState                %% name 
1                                %% number of parents 
CARD_BINARY  CARD_BINARY         %% parent- then self-cardinality 
0.5  0.5 
0.5  0.5 
 
 
## this CPT contains the probability of observing a b-ion given 
## that a fragmentation has or has not occurred at the first 
## position 
6 
init_iBstate                    %% name 
1                               %% number of parents 
CARD_BINARY CARD_BINARY         %% parent then self-cardinality 
DirichletTable squareDirTable   %% meta-counts to be taken from DirichletTable 
1.0  0.0                        %% if parent=0, then child=0 
0.5  0.5                        %% if parent=1, then child=? 
 
 
## these trans?_iBstate CPTs describe the probability of a 
## seeing a b-ion given the current fragmentation event 
## and whether or not the previous b-ion was observed; 
## further there are 5 of these CPTs, one for each 
## "region" of the peptide/HMM ... 
## note the the first parent is fragEvent(0) and the 
## second parent is bObs(-1), and if the current fragmen- 
## tation state is FALSE, then bObs can NOT be TRUE 
7 
transA_iBstate                           %% name 
2                                        %% number of parents 
CARD_BINARY CARD_BINARY  CARD_BINARY     %% parents then self-cardinality 
DirichletTable cubeDirTable              %% meta-counts to be taken from DirichletTable 
1.0  0.0                                 %% fragEvent=0 bObs=0 
1.0  0.0                                 %% fragEvent=0 bObs=1 
0.5  0.5                                 %% fragEvent=1 bObs=0 
0.5  0.5                                 %% fragEvent=1 bObs=1 
 
 
8 
transB_iBstate                           %% name 
2                                        %% number of parents 
CARD_BINARY CARD_BINARY  CARD_BINARY     %% parents then self-cardinality 
DirichletTable cubeDirTable              %% meta-counts to be taken from DirichletTable 
1.0  0.0                                 %% fragEvent=0 bObs=0 
1.0  0.0                                 %% fragEvent=0 bObs=1 
0.5  0.5                                 %% fragEvent=1 bObs=0 
0.5  0.5                                 %% fragEvent=1 bObs=1 
 
 
9 
transC_iBstate                           %% name 
2                                        %% number of parents 
CARD_BINARY CARD_BINARY  CARD_BINARY     %% parents then self-cardinality 
DirichletTable cubeDirTable              %% meta-counts to be taken from DirichletTable 
1.0  0.0                                 %% fragEvent=0 bObs=0 
1.0  0.0                                 %% fragEvent=0 bObs=1 
0.5  0.5                                 %% fragEvent=1 bObs=0 
0.5  0.5                                 %% fragEvent=1 bObs=1 
 
 
10 
transD_iBstate                           %% name 
2                                        %% number of parents 
CARD_BINARY CARD_BINARY  CARD_BINARY     %% parents then self-cardinality 
DirichletTable cubeDirTable              %% meta-counts to be taken from DirichletTable 
1.0  0.0                                 %% fragEvent=0 bObs=0 
1.0  0.0                                 %% fragEvent=0 bObs=1 
0.5  0.5                                 %% fragEvent=1 bObs=0 
0.5  0.5                                 %% fragEvent=1 bObs=1 
 
 
11 
transE_iBstate                           %% name 
2                                        %% number of parents 
CARD_BINARY CARD_BINARY  CARD_BINARY     %% parents then self-cardinality 
DirichletTable cubeDirTable              %% meta-counts to be taken from DirichletTable 
1.0  0.0                                 %% fragEvent=0 bObs=0 
1.0  0.0                                 %% fragEvent=0 bObs=1 
0.5  0.5                                 %% fragEvent=1 bObs=0 
0.5  0.5                                 %% fragEvent=1 bObs=1 
 
 
## this CPT contains the probability of observing a y-ion given 
## that a fragmentation has or has not occurred at the first 
## position 
12 
init_iYstate                      %% name 
1                                 %% number of parents 
CARD_BINARY CARD_BINARY           %% parent then self-cardinality 
DirichletTable squareDirTable     %% meta-counts to be taken from DirichletTable 
1.0  0.0                          %% if parent=0, then child=0 
0.5  0.5                          %% if parent=1, then child=? 
 
 
## these trans?_iYstate CPTs describe the probability of a 
## seeing a y-ion given the current fragmentation event  
## and whether or not the previous y-ion was observed; 
## further there are 5 of these ## CPTs, one for each  
## "region" of the peptide/HMM ... 
## note the the first parent is fragEvent(0) and the 
## second parent is yObs(-1), and if the current fragmen- 
## tation state is FALSE, then yObs can NOT be TRUE 
13 
transA_iYstate                            %% name 
2                                         %% number of parents 
CARD_BINARY CARD_BINARY  CARD_BINARY      %% parents then self-cardinality 
DirichletTable cubeDirTable               %% meta-counts to be taken from DirichletTable 
1.0  0.0                                  %% fragEvent=0 yObs=0 
1.0  0.0                                  %% fragEvent=0 yObs=1 
0.5  0.5                                  %% fragEvent=1 yObs=0 
0.5  0.5                                  %% fragEvent=1 yObs=1 
 
 
14 
transB_iYstate                            %% name 
2                                         %% number of parents 
CARD_BINARY CARD_BINARY  CARD_BINARY      %% parents then self-cardinality 
DirichletTable cubeDirTable               %% meta-counts to be taken from DirichletTable 
1.0  0.0                                  %% fragEvent=0 yObs=0 
1.0  0.0                                  %% fragEvent=0 yObs=1 
0.5  0.5                                  %% fragEvent=1 yObs=0 
0.5  0.5                                  %% fragEvent=1 yObs=1 
 
 
15 
transC_iYstate                            %% name 
2                                         %% number of parents 
CARD_BINARY CARD_BINARY  CARD_BINARY      %% parents then self-cardinality 
DirichletTable cubeDirTable               %% meta-counts to be taken from DirichletTable 
1.0  0.0                                  %% fragEvent=0 yObs=0 
1.0  0.0                                  %% fragEvent=0 yObs=1 
0.5  0.5                                  %% fragEvent=1 yObs=0 
0.5  0.5                                  %% fragEvent=1 yObs=1 
 
 
16 
transD_iYstate                            %% name 
2                                         %% number of parents 
CARD_BINARY CARD_BINARY  CARD_BINARY      %% parents then self-cardinality 
DirichletTable cubeDirTable               %% meta-counts to be taken from DirichletTable 
1.0  0.0                                  %% fragEvent=0 yObs=0 
1.0  0.0                                  %% fragEvent=0 yObs=1 
0.5  0.5                                  %% fragEvent=1 yObs=0 
0.5  0.5                                  %% fragEvent=1 yObs=1 
 
 
17 
transE_iYstate                            %% name 
2                                         %% number of parents 
CARD_BINARY CARD_BINARY  CARD_BINARY      %% parents then self-cardinality 
DirichletTable cubeDirTable               %% meta-counts to be taken from DirichletTable 
1.0  0.0                                  %% fragEvent=0 yObs=0 
1.0  0.0                                  %% fragEvent=0 yObs=1 
0.5  0.5                                  %% fragEvent=1 yObs=0 
0.5  0.5                                  %% fragEvent=1 yObs=1 
 
 
## ---------------------------------------------------------------------------- 
