#-------------------
# $Revision: 1.8 $
#-------------------
from Partition import *
from HitCollection import *
from Utils import *
from Numeric import *
from MLab import *

# from IPython.Shell import IPShellEmbed 	
if __name__ == '__main__':
	# ipshell = IPShellEmbed() 

	if len(sys.argv) < 4: 
		print >>sys.stderr, "Usage: %s <DTASelect-file> <intensity2pid> <partitions> " % (sys.argv[0])
		sys.exit(1)

	h = DtaSelectHitCollection(sys.argv[1])
	f = FileUtils(sys.argv[2])
	p = Partition(sys.argv[3])
	partition_members = []
	for i in range(len(p)):
		partition_members.append(array([]))

	f.columns2dict(1,0)
	min_intensity = 1000.0
	max_intensity = 0.0
	unfound_pids = 0

	for pid in h.pids():
		if f.data["dict"].has_key(str(pid)): 
			intensity = float(f[pid])
			if(intensity < min_intensity): 
				min_intensity = intensity
				min_pid = pid
			if(intensity > max_intensity): 
				max_intensity = intensity
				max_pid = pid
			partition = p.partitionIndex(intensity)
			partition_members[partition] =  \
				concatenate([partition_members[partition], array([intensity])])
		else:
			print >>sys.stderr, pid , " not found for ", h.shortname()
			# unfound_pids = unfound_pids + 1

	print "\t".join(["ExpressionPartition", h.shortname(),"Mean", \
		"Median", "Min", "Max"])
	for idx in range(len(partition_members)):
		print idx, "\t", len(partition_members[idx]), "\t",
		print mean(partition_members[idx]), "\t",
		print median(partition_members[idx]), "\t",
		print min(partition_members[idx]),"\t",
		print max(partition_members[idx])

	#  print >>sys.stderr, h.shortname(), "\tunfound pids %i" % unfound_pids
	print >>sys.stderr, h.shortname(), "\tunfound pids fraction %.3f " % \
		(float(unfound_pids) / len(h.pids()))
	# print >>sys.stderr, "min intensity ", min_intensity, " min pid ", min_pid
	# print >>sys.stderr, "max intensity ", max_intensity, " max pid ", max_pid
