#!/usr/bin/python
#$Revision: 1.8 $
import getopt,sys,re

class Hit:
	"Contains information in a single DtaSelect protein hit."

	def __init__(self):
		self.data = {}
		# The protein hit
		self.data["protein"] = -1
		self.data["gi"] = ""
		self.data["num peptides"] = 0
		self.data["num spectra"] = 0
		self.data["confidence metric"] = -1

	# Eventually the firstScan, lastScan fields will come from 
	# an internal spectrum object.
	def __getitem__(self, key):
		return self.data[key]

	def __setitem__(self, key, item):
		if key == "protein":
			if item.startswith("gi"):
				gi_split = item.split('|')
				self.data["gi"] = gi_split[1] # TODO maybe make a protein object, but not today
		self.data[key] = item		

class DtaSelectHit(Hit):
	"Contains information in a single DtaSelect protein hit."

	def __init__(self):
		Hit.__init__(self)
		self.data["matches"] = [] 
		self.data["allLines"] = []
		self.data["type"] = "real"


	def checkType(self, type_value):
		return (type_value == "real" or type_value == "contam" or type_value == "random")


	def __str__(self):
		return "".join(self.data["allLines"])


	def __setitem__(self, key, item):
		Hit.__setitem__(self, key, item)
		if key == "type": 
			if not self.checkType(item):
				print >>sys.stderr, "ERROR: Attempt to set type to invalid value."
				sys.exit(-1)
		self.data[key] = item
