#$Revision: 1.6 $
import getopt, sys, copy
from MatchCollection import *
from MatchGenerator import *
from HitCollection import *
from HitGenerator import *
from Filter import *
import os
import preproc

class ChargeSieve:

	# Constructor takes optional DtaSelectParams object as input
	def __init__(self, params=None):
		self.data = {}
		self.data["working dir"]="."
		self.dtaHitGen = None
		self.pseudoGen = None
		self.spectrumCollection = None 

	def __getitem__(self, key):
		return self.data[key]

	def __setitem__(self, key, item):
		self.data[key] = item		


		

#-------
# Main
#-------
if __name__ == '__main__':
	if len(sys.argv) < 3: 
		print """Usage: python %s 
	-r <cvector-train-file> 
	-s <sqt-test-filename> 
	-m <ms2-test-filename> 
	-t <cvector-test-file>
	-k <gaussian|polynomial>
""" % (sys.argv[0])
		sys.exit(-1)

	optlist,args = getopt.getopt(sys.argv[1:],'r:s:m:t:k:')

	sqt =  "SQT.sqt"
	ms2 = "MS2"
	train = "CVEC-TRAIN"
	test = "CVEC-TEST"
	kernel = 'polynomial'
	width = 10 
	cVal = 10
	deg = 3
	
	for option_name,option_value in optlist:
		if option_name == '-r':
			train=option_value
		if option_name == '-s':
			sqt=option_value
		if option_name == '-m':
			ms2=option_value
		if option_name == '-t':
			test=option_value
		if option_name == '-k':
			kernel=option_value

	c = ChargeSieve()
	c.dtaHitGen = DtaSelectHitGenerator()
	c.dtaHitGen["params"] = DtaSelectParams()
	
	print >>sys.stderr, "Parsing .sqt file %s." % sqt
	matchCollection = SqtMatchCollection()
 	matchCollection.parseFromFilename(sqt)

	c.pseudoGen = PseudoSequestMatchGenerator(matchCollection)

	print >>sys.stderr, "Parsing .ms2 file %s." % ms2
	spectrumCollection = Ms2SpectrumCollection(ms2)
	spectrumCollection.allSpectra()

	mcfilt = Filter()
	c.spectrumCollection \
		= mcfilt.filterSpectra(spectrumCollection, keep = 'multi-charge')

	print >>sys.stderr, "Parsing training file %s." % train
 	DataSet = datafunc.SparseCDataSet
	trainData = DataSet(train, labelsColumn = 1) 

	rs  = preproc.Rescale()
	rs.train(trainData)

	# data.normalize(1)
	for deg in (1,2,3,4,5,6):
		data.attachKernel('poly', degree = deg) 
		p = modelSelection.Param(svm.SVM(), 'C', [0.001, 0.01, 0.1, 1, 10, 100])
		m = modelSelection.ModelSelector(p, measure='rocArea')
		m.train(data)
		results = m.classifier.loo(data)	
		print "Best C value for degree %i polynomial  = %.3f" % (deg, m.classifier.C)
		print "Best ROC Area for best degree %i polynomial = %.3f" % (deg, results.rocArea)
		
		s = svm.SVM(C=cVal)
		s.train(trainData) 
	
		print "KERNEL = %s, C = %.3f, WIDTH = %i, AREA = %.3f" % \
			(kernel, cVal, gam, area)
