#$Revision: 1.4 $
import getopt, sys, copy, pickle
from MatchCollection import *
from MatchGenerator import *
from HitCollection import *
from HitGenerator import *
from Filter import *
import os
import preproc
import modelSelection


#-------
# Main
#-------
if __name__ == '__main__':
  if len(sys.argv) < 3: 
    print """Usage: python %s 
  -r <cvector-train-file> 
  -o <output file>
  -s <boolean> output results objects?
""" % (sys.argv[0])
    sys.exit(-1)

  optlist,args = getopt.getopt(sys.argv[1:],'r:o:s')

  # set defaults
  train = "CVEC-TRAIN"
  output = "ModelSelectPolynomial.out"
  numFolds = 5
  output_results = False 

  for option_name,option_value in optlist:
    if option_name == '-r':
      train=option_value
    if option_name == '-o':
      output=option_value
    if option_name == '-s':
      output_results = True

  print >>sys.stderr, "Parsing training file %s." % train
  DataSet = datafunc.SparseCDataSet
  trainData = DataSet(train, labelsColumn = 1) 

  print >>sys.stderr, "Rescaling training data." 
  rs  = preproc.Rescale()
  rs.train(trainData)

  # data.normalize(1)
  # TODO option for setting range of C values
  # TODO option for setting range of polynomial degrees
  outFile = open(output, 'w')
  for deg in (1,2,3,4,5,6):
    print >>sys.stderr, "  Training data for degree %i." % deg
    trainData.attachKernel('poly', degree = deg) 
    print >>sys.stderr, "    Polynomial kernal attached."
    p = modelSelection.Param(svm.SVM(), 'C', [0.001, 0.01, 0.1, 1, 10, 100])
    print >>sys.stderr, "    Model parameter calculated."
    m = modelSelection.ModelSelector(p, measure='roc')
    print >>sys.stderr, "    Model Selector constructed."
    # m.train(trainData)
    # print >>sys.stderr, "    Data Trained."
    results = m.stratifiedCV(trainData, numFolds = numFolds)  
    print >>sys.stderr, "    Results calculated"
    if output_results == True:
      resultsFile = open("deg%i.results" % deg, 'w')
      pickle.dump(results,resultsFile)
      resultsFile.close()
    outFile.write("Best ROC Area for best degree %i polynomial = %.3f\n"%\
         (deg, results.roc))
  outFile.close()
