from Numeric import *
import sys

class MyMatrix:
	def __init__(self,filename):
		file = open(filename, 'r')
		self.label = ""
		self.column_labels = []
		self.row_labels = []
		seen_first = False
		row_idx = 0
		values = []
		for line in file:
			if seen_first == False:
				fields = line.split()
				self.label = fields[0]
				self.column_labels = fields[1:]
				seen_first = True
				continue
			row_idx += 1
			fields = line.split()
			self.row_labels.append(fields[0])
			values.append(map(float, fields[1:]))

		self.matrix = array(values, Float)
	
	def __str__(self):
		ret_str = ""
		ret_str += self.label + '\t'
		ret_str += '\t'.join(self.column_labels)	
		ret_str += '\n'
		for first_idx in range(len(self.matrix)):
			ret_str += self.row_labels[first_idx]
			for second_idx in range(len(self.matrix[first_idx])):
				ret_str += '\t' + str(self.matrix[first_idx][second_idx])
			ret_str += '\n'
		return ret_str

if len(sys.argv) < 3:
	raise SystemExit, "More matrices than 1!"
pval_matrix = MyMatrix(sys.argv[1])
bias_matrix = MyMatrix(sys.argv[2])
pval_thresh = 0.01 
new_matrix = MyMatrix(sys.argv[1]) 		# to get the same labels here ...
signed_matrix = MyMatrix(sys.argv[2])	# ... and here
signed_matrix.matrix = floor(bias_matrix.matrix) * 2 + 1
for first_idx in range(len(signed_matrix.matrix)):
	for second_idx in range(len(signed_matrix.matrix[first_idx])):
		if first_idx == second_idx:
			new_matrix.matrix[first_idx][second_idx] = 0
		elif pval_matrix.matrix[first_idx][second_idx] < 0.01:
			sign = signed_matrix.matrix[first_idx][second_idx] 
			new_matrix.matrix[first_idx][second_idx] = sign
		else:
			new_matrix.matrix[first_idx][second_idx] = 0

print str(new_matrix)
