#log# Automatic Logger file. *** THIS MUST BE THE FIRST LINE ***
#log# DO NOT CHANGE THIS LINE OR THE TWO BELOW
#log# opts = Struct({'logfile': 'log'})
#log#-----------------------------------------------------------------------
#
#$Revision: 1.6 $
import sys
class Partition:
	"Contains min and max coords for a series of partitions"
	def __init__(self, filename):
		file = open(filename, 'r')
		self.lines = file.readlines()
		file.close()
		self.ranges = []	
		self.parseLines()
		
	def __len__(self):
		return len(self.ranges)

	def parseLines(self):
		if self.lines[0][0:3] != "(mi" :
			print >>sys.stderr, "Problem parsing line 1", self.lines[0]
			sys.exit(1)

		ranges = []		
		for i in range(len(self.lines)-1):
			idx = i+1
			fields = self.lines[idx].split("\t")
			ranges.append( [ float(fields[0]), float(fields[1].replace("\n","")) ])

		self.ranges = ranges
	
	def partitionIndex(self, value):
		value = float(value)
		for i in range(len(self.ranges)):
			if(value > self.ranges[i][0] and value <= self.ranges[i][1]):
				return i
 		print >>sys.stderr, "Could not find value ", str(value), " in partitions."
		sys.exit(1)


if __name__ == '__main__':
	if len(sys.argv) < 3:
		print >>sys.stderr, "Usage: %s <partition-filename> <values-filename>" % (sys.argv[0])
		sys.exit(1)
	p = Partition(sys.argv[1])
	f = open(sys.argv[2], 'r')
