#$Revision: 1.5 $
import getopt, sys, copy
from MatchCollection import *
from MatchGenerator import *
from HitCollection import *
from HitGenerator import *
from Filter import *
import os
import preproc
import assess

class TestSvm:

	# Constructor takes optional DtaSelectParams object as input
	def __init__(self, params=None):
		self.data = {}
		self.trainData = None

	def __getitem__(self, key):
		return self.data[key]

	def __setitem__(self, key, item):
		self.data[key] = item		


	def printRoc(self, file, kernel = 'polynomial', cVal = 1, width=1, deg=2):
		if kernel in ('Polynomial','polynomial','poly'):
			print >>sys.stderr, "Using polynomial kernel of degree %.3f." % deg
			self.trainData.attachKernel('poly', degree = deg) 
		elif kernel in ('Gaussian','gaussian','rbf'):
			print >>sys.stderr, "Using Gaussian kernel of width %.3f." % width
			self.trainData.attachKernel('gaussian', gamma = width)
			
		print >>sys.stderr, "Training svm with C = %.3f." % cVal
		s=svm.SVM(C=cVal)
		
		r = s.stratifiedCV(self.trainData)
		r.computeStats()
	
		tp, fp, area = assess.roc(r.Y, r.givenY, r.decisionFunc)
		
		print "Area = ", area
		for i in range(len(tp)):	
			file.write("".join([str(fp[i]), "\t", str(tp[i]), "\n"]))
			

#-------
# Main
#-------
if __name__ == '__main__':
	if len(sys.argv) < 3: 
		print """Usage: python %s 
	-r <cvector-train-file> 
	[-k gaussian|polynomial]
	[-w gaussian width]
	[-d polynomial degree]
""" % (sys.argv[0])
		sys.exit(-1)

	optlist,args = getopt.getopt(sys.argv[1:],'r:t:k:w:d:c:')

	train = test = ""
	kernel = 'gaussian'
	width  = cVal = 1
	deg = 2
	
	for option_name,option_value in optlist:
		if option_name == '-s':
			sqt=option_value
		if option_name == '-m':
			ms2=option_value
		if option_name == '-r':
			train=option_value
		if option_name == '-k':
			kernel=option_value
		if option_name == '-w':
			width=float(option_value)
		if option_name == '-d':
			deg=int(option_value)
		if option_name == '-c':
			cVal=float(option_value)

	c = TestSvm()
	
	print >>sys.stderr, "Parsing training file %s." % train
	DataSet = datafunc.SparseCDataSet
	c.trainData = DataSet(train, labelsColumn = 1) 
	rs = preproc.Rescale()
	rs.train(c.trainData)
	
	file = open("".join([train, ".roc"]), "w")
	c.printRoc(file, cVal=cVal,deg=deg,width=width,kernel=kernel) 
	file.close()
	# iter_vals = ( 1, 0.1, 0.01, 0.001 )
	# for cVal in iter_vals:
#
#		kernel = 'polynomial'
# 		for deg in (2,3,4,5,6):
			# area = c.calcRoc(cVal=cVal,deg=deg,width=width,kernel=kernel) 

#		kernel = 'gaussian'
#		for deg in iter_vals:
#			area = c.calcRoc(cVal=cVal,deg=deg,width=width,kernel=kernel) 
	

