#---------------------------------------------------------------------------
# File: bestZscore.py
#---------------------------------------------------------------------------
# Author: $Author: aklammer $
#---------------------------------------------------------------------------
# Revision: $Revision: 1.6 $
#---------------------------------------------------------------------------
# Inputs:
# 
#  - the outputs of hmmTestSpectrum.py, file <prefix>.score, 
#    containing the Z scores and scores for each peptide-spectrum match:
# 
#     spectrum id \t peptide \t zscore \t score \n
# 
#---------------------------------------------------------------------------
import os, os.path, sys, random, cPickle
import Mass
import HmmData
import math
import Numeric
import Spectrum

REVERSE_SORT_ORDER=False


#------------------------------------------------------------------------------
if __name__ == "__main__":
  if len(sys.argv) < 3:
    print >>sys.stderr, """
Usage: %s <score-file-1> ... <score-file-N> <output-prefix>.best
  """ % os.path.basename(sys.argv[0])
    sys.exit(1)


  zscorePrefix = sys.argv[-1]
  fhOut = open(zscorePrefix + ".best", 'w')

  for filename in sys.argv[1:-1]:
    fh = open(filename)
    pep2score = {}
    pep2line = {}
    suid = ""
    for line in fh:
      line = line.rstrip('\n')
      suid, peptide, prob, zscore = line.split()
      pep2score[peptide] = float(zscore)
      pep2line[peptide] = line
    fh.close()
    peps = pep2score.keys()
    
    if REVERSE_SORT_ORDER == True:
      peps.sort(lambda x,y: cmp( pep2score[y], pep2score[x] ))
    else:
      peps.sort(lambda x,y: cmp( pep2score[x], pep2score[y] ))
    fhOut.write('\t'.join([suid, peps[0], str(pep2score[peps[0]])]) + '\n')

  fhOut.close()
