#!/usr/bin/python
#-----------------
# $Revision: 1.7 $
#-----------------
import cPickle, re, sys
import MatchCollection
from random import random

UNIQUE = False
#-------
# Main
#-------
if __name__ == '__main__':

  usage = """Usage: %s <out-pickled-psm> <file-list>
  """

  if len(sys.argv) < 3:
    raise SystemExit, usage % (sys.argv[0])
    
  if not sys.argv[1].endswith(".pickledpsm"):
    print >>sys.stderr, "pickled-psm-filename must end in pickledpsm!"
    raise SystemExit, usage % (sys.argv[0])

  # Input PSMs
  newPsmColl = MatchCollection.PsmMatchCollection()
  seenPeptides = {}
  fileListFile = open(sys.argv[2])
  files = []
  for line in fileListFile:
    line = line.rstrip('\n')
    files.append(line)
  fileListFile.close()
  files.sort(lambda x,y: cmp(random(), random()))
  for idx in range(len(files)):
    print >>sys.stderr, "Loading PSM file %s" % files[idx]
    psmFile = open(files[idx])
    psmColl = cPickle.load(psmFile)
    psmFile.close()
    psmColl["matches"].sort(lambda x,y: cmp(random(), random()))
    for match in psmColl["matches"]:
      if (UNIQUE == True) and (seenPeptides.has_key(match.peptide)): continue
      seenPeptides[match.peptide] = 1
      newPsmColl.appendMatch(match)
    del psmColl
  
  print >>sys.stderr, "Randomly sorting PSM file %s" % sys.argv[1]
  newPsmColl["matches"].sort(lambda x,y: cmp(random(), random()))
  print >>sys.stderr, "Creating PSM file %s" % sys.argv[1]
  cPickle.dump(newPsmColl, open(sys.argv[1], 'w'))

