#-------------------------------------------------------------------------------
# predictMs2.py
#-------------------------------------------------------------------------------
# Given a file in the following format:
# 
#   <peptide>\t<charge>\n
# 
# a cPickled Model, create an Ms2 file with spectra predicted by the Model
# for each peptide at the specified charge state
#-------------------------------------------------------------------------------
import Spectrum
import SpectrumCollection
import Model
import sys, cPickle

#-------
# Main
#-------
if __name__ == '__main__':

  if len(sys.argv) < 4: raise SystemExit, \
        "Usage: %s <peptide> <model> <dta>" %\
            sys.argv[0]

  peptide = sys.argv[1]
  m = cPickle.load(open(sys.argv[2])) 
  dta = Spectrum.DtaSpectrum(sys.argv[3], parsePeaks=True)
  r = Spectrum.RichSpectrum()
  r.addPeptideIons(peptide, z=2)
  m.addIntensityInfo(r)
  print "Sim = ", r.sqrtCosineAngle(dta)

