#!/usr/bin/python
# $Revision: 1.2 $
import getopt,sys,re,copy,os,pickle
from Spectrum import *
from MatchCollection import *
import copy

if __name__ == '__main__':
  if len(sys.argv) < 2:
    print >>sys.stderr, """Usage: %s <dta-directory-1> ... <dta-directory-n> <ms2-output-file-prefix>
    """ % (sys.argv[0])
    sys.exit(1)
  
  outPrefix = sys.argv[-1]
  # increase the scan for each dta file (other than the first) by 10000
  # to ensure different scan numbers
  scanIncrease  = 0
  outFh = open(outPrefix + ".ms2", "w")
  mapFh = open(outPrefix + ".map", "w")
  for dtaFile in sys.argv[1:len(sys.argv)-1]:
    print >>sys.stderr, "Parsing directory %s" % dtaFile
    specColl = DtaSpectrumCollection(dtaFile, parsePeaks=True)
    for dta in specColl.allSpectra():
       s = Ms2Spectrum()
       s.fromDtaSpectrum(dta)
       originalScan = int(s["first scan"])
       s["first scan"] = str(scanIncrease + int(dta["first scan"]))
       outFh.write(str(s))
       mapFh.write("%s\t%i\n" % (s.uid(), originalScan))
    scanIncrease += 10000

  outFh.write("\n")
  outFh.close()
  mapFh.close()
      
