#!/usr/bin/python
#-----------------
# $Revision: 1.2 $
#-----------------
import cPickle, re, sys, os
import Spectrum
import SpectrumCollection
import MatchCollection
from HmmData import *

#-------
# Main
#-------
if __name__ == '__main__':

  usage = """Usage: %s <pickled-psm-filename>
  """

  if len(sys.argv) < 2:
    raise SystemExit, usage % (sys.argv[0])
    
  if not sys.argv[1].endswith(".pickledpsm"):
    print >>sys.stderr, "pickled-psm-filename must end in pickledpsm!"
    raise SystemExit, usage % (sys.argv[0])

  # Input PSMs
  print >>sys.stderr, "Loading PSM file %s" % sys.argv[1]
  psmFile = open(sys.argv[1])
  psmColl = cPickle.load(psmFile)
  psmFile.close()


  print >>sys.stderr, "Analyzing %i PSMs" % len(psmColl["matches"])
  idx=0
  for match in psmColl["matches"]:
    idx+=1
    if idx/10.0 == idx/10: print >>sys.stderr, "Reached idx %i" % idx
    if not Mass.canonicalOnly(match.peptide): 
      print >>sys.stderr, "Skipping non-canonical aa at idx %i" % idx
      continue

    if not match.spectrum["parsePeaks"]: match.spectrum.parsePeaks()

    print match.spectrum

