#!/usr/bin/python

import sys, os

def format_fig(figname):
	if figname == "": return ""
	else: return "\\resizebox{1.25in}{!}{\\includegraphics{./Images/%s}}" % figname

#---------------------
# Main
#---------------------
usage = """Usage: python %s <figs-file>""" 
if len(sys.argv) < 2 : 
	raise SystemExit, usage % (sys.argv[0])
elif not sys.argv[1].endswith(".figs"): 
	raise SystemExit, usage % (sys.argv[0])

# Parse the input figs file
infile = open(sys.argv[1], 'r')
figs = {}
for line in infile:
	line = line.rstrip('\n')
	fig, desc = line.split('\t')
	if figs.has_key(desc): figs[desc].append(fig)
	else: figs[desc] = [fig]
infile.close()

# Output to each tex file
for texDesc in figs.keys():

	outFile = open(texDesc + ".tex", 'w')

	# Table header
	print >>outFile, "\\begin{center}"
	print >>outFile, "\\begin{tabular}{ccc}"

	# Just put in an empty string to guarantee even number of figures
	if len(figs[texDesc])/3.0 != int(len(figs[texDesc])/3.0): 
		figs[texDesc].append("") 

	# Output each figure
	for fig_idx in range(int(len(figs[texDesc])/3.0)):
		print >>outFile, "%s & %s & %s \\\\" % ( format_fig(figs[texDesc][fig_idx*3]), \
			format_fig(figs[texDesc][fig_idx*3 + 1]),\
			format_fig(figs[texDesc][fig_idx*3 + 2]), )

	# Finish the table
	print >>outFile, "\\end{tabular}"
	print >>outFile, "\\end{center}"

	outFile.close()


