# $Revision: 1.2 $
import sys
import Mass
import cPickle
import random
import MatchCollection


usage = "Usage: python splitPsm.py <pickled-psm-file> <idx> <xcorr> <deltCN> <charge> <ion-fraction>"
if len(sys.argv) != 7:
  print >>sys.stderr, usage
  sys.exit(1)

psmFilename = sys.argv[1]
psmFile  = open(psmFilename)
print >>sys.stderr, "Loading %s" % psmFilename
psmColl  = cPickle.load(psmFile)
psmFile.close()
idx = sys.argv[2]
xcorr = float(sys.argv[3])
deltCN = float(sys.argv[4])
charge = int(sys.argv[5])
ionFraction = float(sys.argv[6])

trainPeptides = {}
testPeptides = {}
testPsm  = MatchCollection.PsmMatchCollection()
trainPsm = MatchCollection.PsmMatchCollection()
print >>sys.stderr, "Sorting %s" % psmFilename
psmColl["matches"].sort(lambda x,y: cmp(float(x.spectrum["retention time"]), \
  float(y.spectrum["retention time"])))

print >>sys.stderr, "Filtering %s" % psmFile
psmColl["matches"] = filter(lambda x: float(x["xcorr"])  > xcorr and \
    float(x["deltCN"]) > deltCN and int(x["charge"])==charge, psmColl["matches"])

psmColl["matches"] = filter(lambda x: float(x["matched ions"]) \
  / float(x["expected ions"]) > ionFraction, psmColl["matches"])

psmColl["matches"] = filter(lambda x: x["is normal"], psmColl["matches"])
randMatches = filter(lambda x: not x["is normal"], psmColl["matches"])

#psmColl["matches"] = filter(lambda x: float(x.peptide.) psmColl["matches"])

print >>sys.stderr, "%i PSMs after filtering, with %i randoms" \
  % ( len(psmColl["matches"]), len(randMatches) )

psmColl["matches"].sort(lambda x,y: cmp(random.random(), random.random()))

TRAIN = 0
print >>sys.stderr, "Creating train and test"
for psm in psmColl["matches"]:
  TRAIN += 1
  if trainPeptides.has_key(psm.peptide): 
    trainPsm["matches"].append(psm)
  elif testPeptides.has_key(psm.peptide): 
    testPsm["matches"].append(psm)
  elif TRAIN <= len(psmColl["matches"])/2.0 :
    trainPsm["matches"].append(psm)
    trainPeptides[psm.peptide] = 1
  else:
    testPsm["matches"].append(psm)
    testPeptides[psm.peptide] = 1

print >>sys.stderr, "Dumping test"
testFh = open("test-" + idx + "-" + sys.argv[1], "w")
cPickle.dump(testPsm, testFh)
testFh.close()

print >>sys.stderr, "Dumping train"
trainFh = open("train-" + idx + "-" + sys.argv[1], "w")
cPickle.dump(trainPsm, trainFh)
trainFh.close()
