#-------------------
# $Version$
#-------------------

import pickle, re, sys, os
import Spectrum
import SpectrumCollection
import MatchCollection
import Mass
import HmmOrder
try:
  import Numeric
except:
  print >>sys.stderr, "Could not import Numeric."

DEBUG = False

#--------------------------------------
def writeIonFiles(modelProbs, match, dir, gmtkFiles): 
  """<peptide> is the peptide for which a spectrum will be predicted
  directory in <dir>
  appends to the filelist in gmtkFiles dict (key=type, value=fileList)"""
  assert(os.path.isdir(dir))
  theoretical = Spectrum.RichSpectrum()
  theoretical.addPeptideIons(match.peptide, neutrals=True, multiCharge=True)
  #print theoretical
  theoretical.addNearestIntensitiesFromSpectrum(\
      richObserved, doubleCounting=False)
  peptideInformation = peptideInfo(theoretical.peptide, theoretical["charge"])

  # create the directory for this match
  hmmTrainDataDirName = dir + "/%s-%s.hmmtraindir" % \
      (observed.uid(), match.peptide)

  if not os.path.isdir(hmmTrainDataDirName): os.mkdir(hmmTrainDataDirName)
  for ionType in Spectrum.ION_TYPES:
    # create the file for this ion type
    outputFile = hmmTrainDataDirName + "/" + ionType + ".hmmtrain"
    if gmtkFiles.has_key(ionType): gmtkFiles[ionType].append(outputFile)
    else: gmtkFiles[ionType] = [ outputFile ]
    fh = open(outputFile, 'w')
    peaks = theoretical.getPeaksOfType(ionType)
    # output the peaks
    for peak in peaks: 
      fh.write(sionHmmString(peak, peptideInfo=peptideInformation))
    fh.close()

#-------
# Main
#-------
if __name__ == '__main__':

  if len(sys.argv) < 2:
    raise SystemExit, "Usage: %s <psm-file>" % (sys.argv[0])

  import pickle
  from Spectrum import RichSpectrum
  r = RichSpectrum()
  try: import MatchCollection
  except: pass
  psm = pickle.load(open(sys.argv[1]))
  writeIonFiles(psm, "foo") 
