#$Revision: 1.1 $
import getopt, sys, copy
import pickle 
from Filter import *
from MatchCollection import *
from MatchGenerator import *
from HitCollection import *
from HitGenerator import *
import composite
import os,preproc,time

#-------
# Main
#-------
if __name__ == '__main__':
  if len(sys.argv) < 2: 
    print """Usage: python %s 
  <-r cvector-train-file> 
  <-p prefix>
  [-k gaussian|polynomial]
  [-w gaussian width]
  [-d polynomial degree]
""" % (sys.argv[0])
    sys.exit(-1)

  optlist, args = getopt.getopt(sys.argv[1:],'r:t:k:w:d:c:p:')

  train = "" 
  kernel = 'gaussian'
  width  = 0.010
  cVal = 100
  deg = 2
  
  for option_name,option_value in optlist:
    if option_name == '-r':
      train=option_value
    if option_name == '-k':
      kernel=option_value
    if option_name == '-w':
      width=float(option_value)
    if option_name == '-d':
      deg=int(option_value)
    if option_name == '-c':
      cVal=float(option_value)
    if option_name == '-p':
      prefix=option_value

  if prefix == None: raise SystemExit, "No prefix!"

  DataSet = datafunc.SparseCDataSet
  trainData = DataSet(train, idColumn = 0, labelsColumn = 1) 
  rs = preproc.Rescale()
  rs.train(trainData)

  #if kernel in ('Polynomial','polynomial','poly'):
  #  print >>sys.stderr, "Using polynomial kernel of degree %.3f." % deg
  #  trainData.attachKernel('poly', degree = deg) 
  #elif kernel in ('Gaussian','gaussian','rbf'):
  #  print >>sys.stderr, "Using Gaussian kernel of width %.3f." % width
  #  trainData.attachKernel('gaussian', gamma = width)

  #print >>sys.stderr, "Training svm with C = %.3f." % cVal
  #s=svm.SVM(C=cVal)
  # p = Platt(s)
  #s.train(trainData, saveSpace=False)  

#  for idx in range(len(trainData)):
    # print "F=", s.decisionFunc(trainData, idx)


  # serialize Platt
  #s.save(prefix + ".svm")

  # serialize rescale
  #f = open(prefix + ".rescale", "w")
  #pickle.dump(rs, f) 
  #f.close()

  widths = [ 0.001, 0.010, 0.100, 1, 10, 100]
  Cs = [ 0.001, 0.010, 0.100, 1, 10, 100]
  for width in widths:
    for C in Cs:
      trainData.attachKernel('polynomial', degree = 1)

      print >>sys.stderr, "C = %.3f. w = %.3f" % (C,width)
      s=svm.SVM(C=C)
      # s.train(trainData, saveSpace=False)  
      r = s.stratifiedCV(trainData)
      r.computeStats()

      tp, fp, area = assess.roc(r.Y, r.givenY, r.decisionFunc)

      print >>sys.stderr, "Area = ", area
    
#
#  widths = [ 0.001, 0.010, 0.100, 1, 10, 100]
#  Cs = [ 0.001, 0.010, 0.100, 1, 10, 100]
#  for width in widths:
#    for C in Cs:
#      trainData.attachKernel('gaussian', gamma = width)
#
#      print >>sys.stderr, "C = %.3f, width = %.3f." % \
#          (C, width),
#      s=svm.SVM(C=C)
#      # s.train(trainData, saveSpace=False)  
#      r = s.stratifiedCV(trainData)
#      r.computeStats()
#
#      tp, fp, area = assess.roc(r.Y, r.givenY, r.decisionFunc)
#
#      print >>sys.stderr, "Area = ", area
#  
#
