#---------------------------------------------------------------------------
# File: hmmTrainSion.py
#---------------------------------------------------------------------------
# Author: $Author: aklammer $
#---------------------------------------------------------------------------
# Revision: $Revision: 1.68 $
#---------------------------------------------------------------------------
# Contains params that used to be in separate files, but now are in one
# for centralized control
#---------------------------------------------------------------------------
import os, sys

#
RIPTIDE_HOME=os.getenv("RIPTIDE_HOME")
if not RIPTIDE_HOME: 
  raise SystemExit, "Need to set RIPTIDE_HOME to location of Riptide"

#---------------------------------------------------------------------------
# All processes
#---------------------------------------------------------------------------
ALL_REDO = False

#---------------------------------------------------------------------------
# spectrum generation
#---------------------------------------------------------------------------
MODEL_DIR = "%s/models/" % RIPTIDE_HOME
NUM_REGIONS = 5

#---------------------------------------------------------------------------
# prepareXval.py
#---------------------------------------------------------------------------
NUM_SPLITS = 5
TRAIN_TEST_RATIO = 5
TRAIN_TEST_EXEC  = "%s/python/trainTestSion.py" % RIPTIDE_HOME

#---------------------------------------------------------------------------
# generatePeptides.py
#---------------------------------------------------------------------------
MIN_MASS = 50
MAX_MASS = 5000
MIN_PEPTIDES = 200
MIN_PEPTIDE_LEN = 3 
ITERATIONS = 4
MASS_WINDOW = 2 # +/- 2, so really ~ +/- 2.5

#-- rand negative peptide generation
PRECISION = 30

#-- cand negative peptide generation
CANDIDATE_PEPTIDE_NUMBER = 2

#-------------------------------------------------------------------------------
# Sp.py
#-------------------------------------------------------------------------------
MAX_PEAKS = 200
BETA      = 0.075
RHO       = 0.15
MAX_PEPS  = 2000
# MAX_PEPS  = 10
PEPS_PER_COMMENT=10000
OUTPUT_SCORES = False
TEST_SP = True

#---------------------------------------------------------------------------
# hmmTrainSion.py
#---------------------------------------------------------------------------

OVERWRITE = False
TRAIN = False
GMTK_WRITE_LOG_VALS = 'T' # can be 'T' or 'F'

#---------------------------------------------------------------------------
# hmmTestSpectraSion.py
#---------------------------------------------------------------------------
# WORKING_DIR = "/s0/aklammer/"
WORKING_DIR = "/tmp/"
HMM_TEST_SPECTRUM = "%s/python/testSpectrum.py" % RIPTIDE_HOME
# HMM_SCORE_SPECTRUM = "%s/python/scorePsmMerge.py" % RIPTIDE_HOME
HMM_SCORE_SPECTRUM = "%s/python/scorePsm.py" % RIPTIDE_HOME
# SUFFIX_STRING = ".scores"
SUFFIX_STRING = ".scores"
# PERCOLATOR
# SUFFIX_STRING = ".svminput"
# HMM_TEST_MERGE_SPECTRUM = "%s/python/scorePsmMerge.py" % 
# 2010-04 Is this really the right executable? changed from testSpectrum.py
HMM_TEST_MERGE_SPECTRUM = "%s/python/testSpectrumMerge.py" % RIPTIDE_HOME
MIGRATE_OPTIONS = "-64-bit -requirements 'NikolaDuty_computeserver == TRUE' -J 60 --max-mem 2048"
#MIGRATE_OPTIONS += """-requirements '(NikolaHost == "bird000") || (NikolaHost == "bird001") || (NikolaHost == "bird002") || (NikolaHost == "bird003") || (NikolaHost == "bird004") || (NikolaHost == "bird005") || (NikolaHost == "bird006") || (NikolaHost == "bird007") || (NikolaHost == "bird008") || (NikolaHost == "bird009") || (NikolaHost == "bird010") || (NikolaHost == "bird011") || (NikolaHost == "bird012") || (NikolaHost == "bird013") || (NikolaHost == "bird014") || (NikolaHost == "bird015") || (NikolaHost == "bird016") || (NikolaHost == "bird017") || (NikolaHost == "bird018") || (NikolaHost == "bird019") || (NikolaHost == "bird020") || (NikolaHost == "bird021") || (NikolaHost == "bird022") || (NikolaHost == "bird023") || (NikolaHost == "bird024")' """
REDO = False
NUM_JOBS_IN_CLUSTER = 100
CLEAVAGES='all'
SLEEP_TIME = 5
SLEEP_MAX = 60

#---------------------------------------------------------------------------
# hmmTestSpectrumSion.py
#---------------------------------------------------------------------------
PAIR_MODEL_NAME = 'm2D'
SINGLE_MODEL_NAME = 'singleIon-a'
APPEND_TRUE_PEP = False

CLEANUP = True

#---------------------------------------------------------------------------
# GMTK
#---------------------------------------------------------------------------
# KERNEL = 'accumulator'
# KERNEL = 'accumulator'
# KERNEL = 'fisher'
KERNEL = 'lor'
GAUSSIAN_NORM = False

#---------------------------------------------------------------------------
# hmmAccuracySionSvm.py
#---------------------------------------------------------------------------

#---
# All
#---
S_DIR="/s0"


#---------------------
# Avoid rerunning if file "looks good"
#---------------------
def looksGood(filename):
  if os.path.isfile(filename) and not ALL_REDO:
    if os.path.getsize(filename) > 0:
      print >>sys.stderr, "Using old %s" % filename
      return True
    else:
      print >>sys.stderr, "Ignoring zero size %s" % filename

  return False
