#!/usr/bin/python
#-----------------
# $Revision: 1.4 $
#-----------------
import cPickle, re, sys, os
import MatchCollection
from random import random

#-------
# Main
#-------
if __name__ == '__main__':

  usage = """Usage: %s <in-pickled-psm> <num-dups>"""

  if len(sys.argv) < 3:
    raise SystemExit, usage % (sys.argv[0])
    
  if not sys.argv[1].endswith(".pickledpsm"):
    print >>sys.stderr, "pickled-psm-filename must end in pickledpsm!"
    raise SystemExit, usage % (sys.argv[0])

  # Input PSMs
  newPsmColl = MatchCollection.PsmMatchCollection()
  print >>sys.stderr, "Loading PSM file %s" % sys.argv[1]
  psmFile = open(sys.argv[1])
  psmColl = cPickle.load(psmFile)
  psmFile.close()
  
  maxPeps = int(sys.argv[2])

  # randomize the matches
  pepCounts = {}
  psmColl["matches"].sort(lambda x,y: cmp(random(), random()))
  for match in psmColl["matches"]:
    if pepCounts.has_key(match.peptide): pepCounts[match.peptide] += 1
    else: pepCounts[match.peptide] = 0
    if pepCounts[match.peptide] >= maxPeps: continue
    newPsmColl.appendMatch(match)
  
  newPsmColl["matches"].sort(lambda x,y: cmp(random(), random()))
  newPsmCollLabel = os.path.basename(sys.argv[1]).split('.')[0] + "-lowdup-%i.pickledpsm" % maxPeps
  print >>sys.stderr, "Creating PSM file %s" % newPsmCollLabel
  cPickle.dump(newPsmColl, open(newPsmCollLabel, 'w'))

