#!/usr/bin/python
#-----------------
# $Revision: 1.2 $
#-----------------
import cPickle, re, sys
import compile_aa_stats  
import Spectrum
import SpectrumCollection
import MatchCollection
import Model

#-------
# Main
#-------
if __name__ == '__main__':

	usage = """Usage: %s <pickled-psm-filename> <pickled-model-filename> <meta-spec-ID> <scan-ID> <charge>
	For SUID spectrum in the <pickled-psm-filename>, predict a spectrum
	using the model in <pickled-model-filename> and output the spectra 
	score.""" 

	# TODO add different similarity score calculations
	if len(sys.argv) < 6:
		raise SystemExit, usage % (sys.argv[0])

	if not sys.argv[1].endswith(".pickledpsm"):
		print >>sys.stderr, "pickled-psm-filename must end in pickledpsm!"
		raise SystemExit, usage % (sys.argv[0])

	# Input PSMs
	print >>sys.stderr, "Loading PSM file %s" % sys.argv[1]
	psmFile = open(sys.argv[1])
	psmColl = cPickle.load(psmFile)
	psmFile.close()

	# Input Model
	print >>sys.stderr, "Loading model file %s" % sys.argv[2]
	modelName = sys.argv[2]
	model = None
	if not modelName == "REAL":
		modelFile = open(modelName)
		model = cPickle.load(modelFile)
		modelFile.close()

	# make SUID
	suid = Spectrum.spectrumUID(sys.argv[4], sys.argv[3], sys.argv[5])

	# Calculate similarity scores
	idx = 0
	scores = []
	for match in psmColl["matches"]:
		observed = match.spectrum
		if not observed.uid() == suid: 
			continue
		if modelName == "REAL":
			observed.sumNormalizeIntensity()
			print observed
			break

		# use model to determine the "theoretical" ion spectra
		theoretical = Spectrum.RichSpectrum()
		theoretical.addPeptideIons(match.peptide)
		theoretical.addSpectrumInfo(match.spectrum)
		model.addIntensityInfo(theoretical)
		theoretical.sumNormalizeIntensity()
		print >>sys.stderr, "Cosine angle = %.3f" % theoretical.cosineAngle(observed)
		print theoretical
