# $Revision: 1.2 $
import sys
import Mass
from Bio import Fasta
MAX_MZ = 3000
MIN_MZ = 400
CHARGE = 2
MIN_LEN = 2
parser = Fasta.RecordParser()
usage = "Usage: python makeTryptic.py <protein-fasta-filename>"
if len(sys.argv) != 2:
  print >>sys.stderr, usage
  sys.exit(1)

def within_mass(peptide):
  mz = Mass.peptide_mass(peptide) / CHARGE
  return MIN_MZ < mz and mz < MAX_MZ

file  = open(sys.argv[1])
iterator = Fasta.Iterator(file, parser)
cur_record = iterator.next()
seq_list = []
protein_count = 0
record_count = 0
while cur_record != None:
  record_count = record_count + 1  
  if record_count % 100 == 0:
    print >>sys.stderr, "Reached sequence %i" % record_count
  seq = cur_record.sequence
  tryptic_seq = []
  for i in range(len(seq)):
    tryptic_seq.append(seq[i])
    if (seq[i] == 'K' or seq[i] == 'R'):
      if i < len(seq)-1:
        if seq[i+1] != 'P':
          peptide = ''.join(tryptic_seq)
          if len(peptide) >= MIN_LEN and within_mass(peptide):
            print peptide + "\t%i" % CHARGE
          tryptic_seq = []
      else:
        if len(tryptic_seq) >= MIN_LEN and within_mass(peptide):
          peptide = ''.join(tryptic_seq)
          print ''.join(tryptic_seq) + "\t%i" % CHARGE

        tryptic_seq = []
      
  cur_record = iterator.next()
