#!/usr/bin/python
import getopt, sys, re
from cPickle import *
from MatchCollection import *
from SpectrumCollection import *
import Mass

#--------------------------
if __name__ == '__main__':
  if len(sys.argv) < 2:
    print "Usage: %s <ms2-filename> <output-psm>" % (sys.argv[0])
    sys.exit(1)

  print >>sys.stderr, "Parsing ms2"
  ms2 = Ms2SpectrumCollection(sys.argv[1], parsePeaks=False, saveSpace=False)
  matchCollection = PsmMatchCollection()
  for spectrum in ms2.allSpectra():
    match = Match()
    match.spectrum = spectrum
    match.charge = spectrum["charge"]
    matchCollection.appendMatch(match)
  file = open(sys.argv[2], 'w')
  dump(matchCollection, file)
  file.close()
