#!/usr/bin/python
# $Revision: 1.7 $
import getopt,sys,re,copy,os
from SpectrumCollection import *

if __name__ == '__main__':
	if len(sys.argv) < 3:
		print >>sys.stderr, "Usage: %s <new-ms2-filename> <old-ms2-dir-prefix> [number-in-dir]" % (sys.argv[0])
		sys.exit(1)

	ms2_file = sys.argv[1]
	dir_prefix = sys.argv[2]
	number_in_dir = int(sys.argv[3])
	specColl = Ms2SpectrumCollection(ms2_file)
	# oldSpecColl = OldMs2SpectrumCollection(specColl)
	# spectra = oldSpecColl.allSpectra()
	spectra = specColl.allSpectra()

	# number of files will actually be one more than "number"
	number = int( float(len(spectra)) / number_in_dir )
	for partition_idx in range(number):
		print >>sys.stderr, "Opening file %i" % partition_idx
		name = dir_prefix + str(partition_idx) 
		os.mkdir(name + ".dir")
		file = open(name + ".dir/" + name + ".ms2",'w')
		for spectrum_idx in range(partition_idx * number_in_dir, \
															(partition_idx + 1) * number_in_dir):
			spectra[spectrum_idx]["suppress comments"] = 1
			file.write(str(spectra[spectrum_idx]))
		file.close()
	
	# final file
	if number * number_in_dir < len(spectra):
		print >>sys.stderr, "Opening file %i" % number
		name = dir_prefix + str(number) 
		os.mkdir(name + ".dir")
		file = open(name + ".dir/" + name + ".ms2",'w')
		for spectrum_idx in range(number * number_in_dir, len(spectra)):
			spectra[spectrum_idx]["suppress comments"] = 1
			file.write(str(spectra[spectrum_idx]))
		file.close()
