#!/usr/bin/python
# $Revision: 1.4 $
import getopt,sys,re,copy,os
from SpectrumCollection import *

if len(sys.argv) < 3:
	print >>sys.stderr, "Usage: %s <ommsa-xml-file> <input-ms2-file>" % (sys.argv[0])
	sys.exit(1)

ommsa_filename = sys.argv[1]
specColl = Ms2SpectrumCollection(sys.argv[2])
file = open(ommsa_filename, 'r')
id = z = peptide = expect = db = "" 
idx = 0
prefix, db, supersuffix = ommsa_filename.split(',')
prefix = prefix.replace("-ms2","")
for line in file:
	line = line.lstrip()
	if line.startswith("<MSHitSet_number"):
		index = int( line[line.find('>')+1:line.rfind('<')] )
		if index >= len(specColl["spectra"]):
			print >>sys.stderr, "Problem with ", index 
			sys.exit(1)
		id =  specColl["spectra"][index]["first scan"]
		z =  specColl["spectra"][index]["charge"]
	elif line.startswith("<MSHits_evalue"):
		expect = float( line[line.find('>')+1:line.rfind('<')] )
	elif line.startswith("<MSHits_pepstring"):
		peptide = line[line.find('>')+1:line.rfind('<')]
		print '\t'.join([ prefix, str(id), db, peptide, str(z), str(expect)])

file.close()
