#!/usr/bin/python
# $Revision: 1.2 $
import getopt,sys,re,copy,os
from MatchCollection import *
from SpectrumCollection import *

if len(sys.argv) < 2:
	print >>sys.stderr, "Usage: %s <pepnovo-file> <ms2-file>" % (sys.argv[0])
	sys.exit(1)

pepnovo_filename = sys.argv[1]
ms2_filename = sys.argv[2]
specCollection = Ms2SpectrumCollection(ms2_filename)
file = open(pepnovo_filename, 'r')
pepnovo_match_lines = []
matches = []
spectrum_err = spectrum_total = 0
match = ""
seen_first = False
for line in file:
	if not seen_first:
		seen_first = True
		continue

	if line.startswith("="):
		spectrum_total+=1
		try:
			match = PepnovoMatch(pepnovo_match_lines, specCollection)
		except Exception, e:
			spectrum_err+=1
		else:
			print str(match),

		pepnovo_match_lines = []

	pepnovo_match_lines.append(line)

spectrum_total+=1
try:
	match = PepnovoMatch(pepnovo_match_lines, specCollection)
except ParseSpectrumException, e:
	spectrum_err+=1	
else:
	print str(match),

print >>sys.stderr, "Could not find an adequate match in %i out of %i spectra." \
		% (spectrum_err, spectrum_total)
