#!/usr/bin/python
# $Revision: 1.8 $
import getopt,sys,re,copy,os
from MatchCollection import *
import Mass

FILTER = True
MASS_TOL = 0.1

if len(sys.argv) < 2:
	print >>sys.stderr, "Usage: %s <sqt-file-1> ... <sqt-file-n>" % (sys.argv[0])
	sys.exit(1)

#--------------------------------
def match_meets_criteria(match):
  peptide = match["peptide"]

  if peptide[0] == '-' or peptide[-1] == '-':
    return False

  if match["xcorr"].find("nan") > -1: # nan xcorr
    return False

  if Mass.canonicalOnly(peptide) == False: return False
  pepMass = Mass.peptide_mass(peptide, z=int(match["charge"]))
  spectrumMass = float(match["M+H+"]) + (int(match["charge"]) - 1) * Mass.mono_mass('H_plus')
  if pepMass < spectrumMass - MASS_TOL or spectrumMass + MASS_TOL < pepMass:
    return False

  return True
  
#--------------------------------
for sqt_filename in sys.argv[1:]:
  matches = SqtMatchCollection()
  matches.parseFromFilename(sqt_filename)
  prefix = ""
  if sqt_filename.find(",") > -1: 
    prefix, suffix, id = sqt_filename.split(',')
  else: 
    prefix, suffix = os.path.basename(sqt_filename).split('.')
  prefix = prefix.replace("-ms2","")
  list = matches.allMatches()
  for match in list:
    if not match_meets_criteria(match): continue
    db = ""
    if (match["locus"].find("rand") > -1) or (match["locus"].find("shuffled") > -1):
      db = "rand"	
    else:
      db = "normal"

    peptide = match["peptide"]

    print '\t'.join([prefix, str(match["firstScan"]), db, peptide, \
      str(match["charge"]), match["xcorr"], match["deltCN"]])


