#----
# Plots the means and stddevs of features in a comma delimited file, on in 
# each figure
#----
import sys
import Fit
import pylab
import math

if len(sys.argv) < 2: 
  raise SystemExit,"Usage: %s <svm-input-file>" % sys.argv[0]

svmFile = sys.argv[1]
fh = open(svmFile)
matrix = []
for line in fh:
  matrix.append(map(float, line.split(",")[1:]))
fh.close()

print "Done reading in file!"


means = []
stddevs = []
for col_idx in range(len(matrix[0])):
  col_values = []
  for row_idx in range(len(matrix)):
    col_values.append(matrix[row_idx][col_idx])
  mean, stddev = Fit.fit_gaussian(col_values)
  means.append(math.log(abs(mean)+1.0))
  stddevs.append(math.log(stddev + 1.0))

print "Done calculating parameters!"

means.sort()
stddevs.sort()
pylab.plot(range(len(means)), means)
# pylab.loglog()
pylab.title("ln( |mean| + 1.0 )")
pylab.savefig("means.eps")
pylab.savefig("means.png")
pylab.hold(False)

pylab.plot(range(len(stddevs)), stddevs)
# pylab.loglog()
pylab.title("ln( stddev + 1.0)")
pylab.savefig("stddevs.eps")
pylab.savefig("stddevs.png")
#



