from pylab import *
FDR = 0.01
#styles = ['k-','k--','k-.']
#color = [(100.0,100.0,100.0),(0.0,0.0,0.0), (50.0,50.0,50.0)]

def parse(file):
  fh = open(file)
  xs = []; ys = [];
  for line in fh:
    fields = line.rstrip('\n').split()
    xs.append(float(fields[0])); ys.append(float(fields[1]));
  fh.close()
  return xs, ys

hold(True)
idx = 0
max_x  = 1
max_y = 1

for file in sys.argv[2:]:
  minutes = file.split('.')[0]
  minutes += " min"
  if minutes.startswith('240'): minutes = 'None'
  xs, ys = parse(file)
  #plot(xs, ys, styles[idx%3], color=color[int(idx/2.0)],label=minutes)
  plot(xs, ys) #, styles[idx%3], color=color[int(idx/2.0)],label=minutes)
  idx += 1

  for roc_idx in range(len(xs)):
    if xs[roc_idx] <= 0.00001: continue
    if float(xs[roc_idx]) / float(ys[roc_idx]) > FDR:
      if xs[roc_idx] > max_x: max_x = xs[roc_idx]
      if ys[roc_idx] > max_y: max_y = ys[roc_idx]
      break

max_x *= 1.2
max_y *= 1.2
name = sys.argv[1]
# find where we first cross the 1% FDR line
title(name, size=24)
fdr_x = range(0,int(max_x))
fdr_y = range(0,int(max_y),100)
min_len = min([ len(fdr_x), len(fdr_y) ])
fdr_x = fdr_x[0:min_len]
fdr_y = fdr_y[0:min_len]

plot( range(0,int(max_y),100), label="i% FDR" % int(FDR * 100))
axis([0,max_x,0,max_y])
xticks(size=12)
yticks(size=12)
#legend(loc = (0.5,0) ) # loc='lower right')
xlabel("FP (rand)", size=24)
ylabel("TP (norm)", size=24)
#savefig("first-draft.eps")
savefig("%s.png" % name.split('.')[0], dpi='60')
show()
