#!/usr/bin/python
import getopt, sys, re
import cPickle
from MatchCollection import *
from SpectrumCollection import *
from pylab import *
import retentionRoc
import Mass
from scipy import stats
import filterTestPsm
##
#if __name__ == '__main__':
#  if len(sys.argv) < 3:
#    print "Usage: %s <sqt-filename> <ms2-filename> <output-psm>" % (sys.argv[0])
#    sys.exit(1)
#
#  sqt = SqtMatchCollection()
#  sqt.parseFromFilename(sys.argv[1])
#  sqt.allMatches()
#  ms2 = Ms2SpectrumCollection(sys.argv[2], parsePeaks=False)
#  for spectrum in ms2.allSpectra():
#    del spectrum["peaks"]
#    del spectrum["peakLines"]
#  sqt.addSpectrumInfo(ms2)
#  sqt["file"] = None
#  file = open(sys.argv[3], 'w')
#  dump(sqt, file)
#  file.close()

global aminoToIdx
aminoToIdx = {}
for idx in range(len(Mass.CanonicalAminos)):
  aminoToIdx[Mass.CanonicalAminos[idx]]=idx
# print aminoToIdx

def sequenceToRetentionFeatures(peptide):

  totalCounts = [0] * len(Mass.CanonicalAminos)
  for idx in range(len(peptide)):
    totalCounts[aminoToIdx[peptide[idx]]]+=1

  ntermCount = [0] * len(Mass.CanonicalAminos)
  ntermCount[aminoToIdx[peptide[0]]]+=1
  return (ntermCount + totalCounts)
  #return totalCounts

#if __name__ == '__main__':
#  if len(sys.argv) < 2:
#    print "Usage: %s <cPickled-psm>" % (sys.argv[0])
#    sys.exit(1)
#
#  psmFilename = sys.argv[1]
#  psm = cPickle.load(open(psmFilename))
#  svrLines = []
#  seenPeptides = {}
#  for match in psm["matches"]:
#    if seenPeptides.has_key(match.peptide): continue
#    seenPeptides[match.peptide] = 1
#    features = sequenceToRetentionFeatures(match.peptide)
#    label  = match.spectrum["retention time"]
#    uid = '-'.join(match.spectrum.uid().split(','))
#    allFields = [uid + "-" + match.peptide, label] + features
#    svrLines.append(allFields)
#
#
#  outFile = os.path.basename(psmFilename).split('.')[0] + ".svrinput"
#  file = open(outFile, 'w')
#  for line in svrLines:
#    file.write( ','.join(map(str, line)) + "\n" )   
#  file.close()
#



if __name__ == '__main__':
  if len(sys.argv) < 2:
    print "Usage: %s <psm>" % (sys.argv[0])
    sys.exit(1)

  psmCollName = str(sys.argv[1])
  filtered = filterTestPsm.filterPsm(psmCollName, tryptic=True, charge=2)
  filteredPsm = cPickle.load(open(filtered))
  plotRetention(filteredPsm["matches"])


