# $Revision: 1.8 $
import sys
import Mass
import cPickle
import random
import MatchCollection
import os
from hmmParams import *
usage = "Usage: python prepareXval.py <pickled-psm-file> <fasta-file> <model> <param-prefix>" 
if len(sys.argv) != 5:
  print >>sys.stderr, usage
  sys.exit(1)

psmFile  = open(sys.argv[1])
fastaFname = sys.argv[2]
model = sys.argv[3]
paramPrefix = sys.argv[4]

psmColl  = cPickle.load(psmFile)
psmFile.close()

prefix = sys.argv[1].split('.')[0] + "," \
    + os.path.basename(fastaFname).split('.')[0] + "," \
    + model + "," + paramPrefix 
migrateFname = prefix + ".migrate"
migrateFh = open(migrateFname, "w")
splitDname = os.getcwd() + os.sep + prefix + ".splits"
if not os.path.isdir(splitDname): os.mkdir(splitDname)
FULL_PREP = False
for idx in range(NUM_SPLITS):
  curSplitDname = splitDname + os.sep + str(idx) + ".split"
  trainFname = curSplitDname + os.sep + "train.pickledpsm"
  testFname = curSplitDname + os.sep + "test.pickledpsm"
  migrateFh.write("cd %s; python %s %s %s %s %s %s\n" \
      % (curSplitDname, TRAIN_TEST_EXEC, trainFname, testFname, \
      fastaFname, model, paramPrefix + str(idx))) 

  if FULL_PREP == False : continue

  trainPeptides = {}
  testPeptides = {}
  testPsm  = MatchCollection.PsmMatchCollection()
  trainPsm = MatchCollection.PsmMatchCollection()
  psmColl["matches"].sort(lambda x,y: cmp(random.random(), random.random()))
  trainCount = 0

  for psm in psmColl["matches"]:
    if trainPeptides.has_key(psm.peptide): 
      trainPsm["matches"].append(psm)
    elif testPeptides.has_key(psm.peptide): 
      testPsm["matches"].append(psm)
    elif trainCount == TRAIN_TEST_RATIO:
      testPsm["matches"].append(psm)
      testPeptides[psm.peptide] = 1
      trainCount = 0
    else:
      trainPsm["matches"].append(psm)
      trainPeptides[psm.peptide] = 1
      trainCount += 1

  if not os.path.isdir(curSplitDname): os.mkdir(curSplitDname)

  testFh = open(testFname, "w")
  cPickle.dump(testPsm, testFh)
  testFh.close()

  trainFh = open(trainFname, "w")
  cPickle.dump(trainPsm, trainFh)
  trainFh.close()


  curDname = os.getcwd()
  os.chdir(curSplitDname)
  # os.link(fastaFname, os.path.basename(fastaFname))
  os.chdir(curDname)
  fastaFname = os.path.abspath(fastaFname)

  
migrateFh.close()
