#!/usr/bin/python
# $Revision: 1.2 $
import getopt,sys,re,copy,os
from PsmFilter import *
#---
# Begin main
#---
if len(sys.argv) < 2:
  print >>sys.stderr, "Usage: %s <exclude-peps> <output-file-prefix> <psm-filename-1> ... <psm-filename-n>" % (sys.argv[0])
  sys.exit(1)

all_matches = {}
tryptic_matches = {}

print >>sys.stderr, "\n",

for idx in range(3,len(sys.argv)):
  prefix, suffix  = sys.argv[idx].split('.')
  print >>sys.stderr, "Reading file %s" % sys.argv[idx]
  unfiltered_matches = parse_matches(sys.argv[idx])
  filtered_by_length = filter_length(unfiltered_matches)
  for match_key, match_value in filtered_by_length.items():
    all_matches[match_key] = match_value
  for match_key, match_value in filter_tryptic(filtered_by_length).items():
    tryptic_matches[match_key] = match_value

print >>sys.stderr, "\nAnalyzing all matches.\n" # add tryptic later if nec.
real_peps = {}

fh = open(sys.argv[1])
for line in fh:
  line = line.rstrip('\n')
  real_peps[line] = 1

for match_key, match_value in all_matches.items():
  # the match is real
  if match_key[2] == 0:
    peptide = match_value[0] 
    real_peps[ peptide ] = 1

random_matches = {}
for match_key, match_value in tryptic_matches.items():
  # the match is random
  if match_key[2] == 1:
    # the pep is not real
    if not real_peps.has_key(match_value[0]):
      random_matches[match_key] = match_value

file = open(sys.argv[2] + ".psm", "w")
for random_match_key, random_match_value in random_matches.items():
  file.write( "\t".join( map(str, [ random_match_key[0], random_match_key[1], \
    "random",  random_match_value[0], random_match_value[1], \
    random_match_value[2],  ])) + "\n")
file.close()
