#!/usr/bin/python
import getopt, sys, re
from cPickle import *
from MatchCollection import *
from SpectrumCollection import *
from Mass import *

if len(sys.argv) < 3:
	print "Usage: %s <pickledpsm-input> <pickledpsm-output>  >  <mass-diffs>" % (sys.argv[0])
	sys.exit(1)

psmIn = load(open(sys.argv[1]))
psmOut = PsmMatchCollection()

for match in psmIn["matches"]:
  peptideMass = peptide_mass(match.peptide, z=2)
  spectrumMass = mono_mass('H_plus') + match.spectrum["assumed m"]

  massDelta = peptideMass - spectrumMass
  print massDelta
  if abs(massDelta) <= tol_mass('pephmm'):
    psmOut.appendMatch(match)
  else:
    print "%s %.3f" % ( match.spectrum.uid(), massDelta ) 

file = open(sys.argv[2], 'w')
dump(psmOut, file)
file.close()

