#--------------------------------------------------------
# $Revision: 1.7 $
#--------------------------------------------------------
import getopt, sys

#--------------------------------------------------------
if __name__ == '__main__':
  if len(sys.argv) < 2: 
    print """Usage: python %s 
  <-r train-file> 
  <-p prefix>
  [-k gaussian|polynomial]
  [-w gaussian width]
  [-d polynomial degree]
  [-m matrix 2 png input]
""" % (sys.argv[0])
    sys.exit(-1)

#--------------------------------------------------------
import cPickle, composite, preproc, time, datafunc, svm, assess
import modelSelection
from hmmParams import *

#--------------------------------------------------------
# Returns prefix to svmFname, rescaleFname 
#--------------------------------------------------------
def main(train=None, prefix='foo',kernel='polynomial',width=None,degree=1):

  svmFname = prefix + '.svm'
  rescaleFname = prefix + '.rescale'
  if looksGood(svmFname) and looksGood(rescaleFname):
    return svmFname, rescaleFname

  DataSet = datafunc.SparseCDataSet
  trainData = DataSet(train, idColumn = 0, labelsColumn = 1) 
  rs = preproc.Rescale()
  rs.train(trainData)

  if kernel in ('Polynomial','polynomial','poly'):
    print >>sys.stderr, "Using polynomial kernel of degree %.3f." % degree
    trainData.attachKernel('poly', degree = degree) 
  elif kernel in ('Gaussian','gaussian','rbf'):
    print >>sys.stderr, "Using Gaussian kernel of width %.3f." % width
    trainData.attachKernel('gaussian', gamma = width)

  s = svm.SVM()
  #p = modelSelection.Param(s, 'C', [0.1,1,10,100,1000])
  p = modelSelection.Param(s, 'C', [0.1, 1, 10, 100, 1000])

  ms = modelSelection.ModelSelector(p)

  ms.train(trainData)

  # serialize SVM
  svmFh = open(svmFname, 'w')
  ms.save(svmFh)
  svmFh.close()

  # serialize rescale
  f = open(rescaleFname, "w")
  cPickle.dump(rs, f) 
  f.close()

  # tp, fp, area = assess.roc(r.Y, r.givenY, r.decisionFunc)

  #print "Area = ", area

  return prefix
  
#--------------------------------------------------------
if __name__ == '__main__':
  optlist, args = getopt.getopt(sys.argv[1:],'r:t:k:w:d:c:p:m:')
  train = kernel = width = degree = cvalue = prefix = None
  for option_name,option_value in optlist:
    if option_name == '-r': train=option_value
    if option_name == '-k': kernel=option_value
    if option_name == '-w': width=float(option_value)
    if option_name == '-d': degree=int(option_value)
    if option_name == '-p': prefix=option_value

  prefix = main(train=train, prefix=prefix, kernel=kernel, \
      width=width, degree=degree)
