#--------------------------------------------------------
# $Revision: 1.14 $
#--------------------------------------------------------
import getopt, sys

#--------------------------------------------------------
if __name__ == '__main__':
  if len(sys.argv) < 2: 
    print """Usage: python %s 
  <-r train-file> 
  <-p prefix>
  <-s> standardize data
""" % (sys.argv[0])
    sys.exit(-1)

#--------------------------------------------------------
import cPickle, composite, preproc, time, datafunc, svm, assess
import modelSelection
from hmmParams import *
import Svm

#--------------------------------------------------------
# Returns svm, resultset
#--------------------------------------------------------
def main(train=None, prefix=None, standardize=True):

  svmFname = prefix + '.svm'
  rescaleFname = prefix + '.rescale'

  if looksGood(rescaleFname) and looksGood(svmFname):
    return prefix

  DataSet = datafunc.SparseCDataSet
  trainData = DataSet(train, idColumn = 0, labelsColumn = 1) 
  if standardize == True:
    rs = preproc.Rescale()
    rs.train(trainData)

    # serialize rescale
    f = open(rescaleFname, "w")
    cPickle.dump(rs, f) 
    f.close()

  svmSelect = modelSelection.SVMselect()
  svmSelect.train(trainData)
  results = svmSelect.classifier.test(trainData)	
  results.computeStats()

  print >>sys.stderr, "Best ROC Area for best svm = %.3f" \
      %  float(results.roc)
  print >>sys.stderr, "Best BSR Area for best svm = %.3f" \
      % results.balancedSuccessRate

  # serialize SVM

  svmSelect.classifier.train(trainData, saveSpace=False)
  svmSelect.classifier.save(svmFname)
  svm = Svm.Svm()
  svm.write(rescale=rs, classifier=svmSelect.classifier, 
      output="%s.svmobject" % prefix)

  return prefix
  
#--------------------------------------------------------
if __name__ == '__main__':
  optlist, args = getopt.getopt(sys.argv[1:],'r:p:s')
  train = prefix = standardize = None
  for option_name,option_value in optlist:
    if option_name == '-r': train=option_value
    if option_name == '-p': prefix=option_value
    if option_name == '-s': standardize=True

  prefix = main(train=train, prefix=prefix, standardize=standardize)

