#!/usr/bin/python2.4
#------------
# $Revision: 1.3 $
#------------
import getopt, sys, re, os, os.path, math
try:
  import Numeric
except:
  print >>sys.stderr, "Warning: Could not import Numeric in compileAaStats."
from Spectrum import *
from SpectrumCollection import *

SIGNED_RANK = "signed-rank"
MIN_NON_ZERO = 1
THRESH = 0.5

def value(vals, thresh):
  copy = [ i for i in vals ]
  copy.sort()
  for idx in range(len(copy)):
    if copy[idx] > thresh: 
      return (len(copy) - idx) / float(len(copy)) * 100
  return 0.0

def medianDiff(vals1, vals2):
  diffs = [ vals1[i] - vals2[i] for i in range(len(vals1)) ]
  if (len(diffs) % 2) == 1:
    return diffs[int(len(diffs)/2)]
  else:
    diff1 = diffs[int(len(diffs)/2)] 
    diff2 = diffs[int(len(diffs)/2)+1] 
    return (diff1 + diff2)/2.0

def pval(vals1, vals2):
  diffs = [ vals1[i] - vals2[i] for i in range(len(vals1)) ]
  p = os.popen2(SIGNED_RANK)
  for diff in diffs:
    print >>p[0], diff
  p[0].close()
  output = p[1].read().split()
  output[4].rstrip('\n')
  return output[4].replace('p-value=','')

#-------
# Main
#-------
if __name__ == '__main__':

  if len(sys.argv) < 2:
    raise SystemExit, "Usage: %s <sim-file-1> ... <sim-file-n>" % (sys.argv[0])

  simFiles = sys.argv[1:]
  sims = {}
  for sim in simFiles:
    sims[sim] = []
    f = open(sim)
    for line in f:
      line.rstrip('\n')
      sims[sim].append(float(line))
    f.close()
  
  print
  for idx1 in range(len(simFiles)):
    for idx2 in range(idx1,len(simFiles)):
      sim1 = simFiles[idx1]
      sim2 = simFiles[idx2]
      if sim1 == sim2: continue
      print sim1, " vs ", sim2
      print "  MedianDiff = ", medianDiff(sims[sim1],sims[sim2])
      print "  P-value = ", pval(sims[sim1], sims[sim2])
      print "  Percent %s above %.2f = %.1f" % \
        (sim1, THRESH, value(sims[sim1], THRESH))
      print "  Percent %s above %.2f = %.1f" % \
        (sim2, THRESH, value(sims[sim2], THRESH))
      print

