#------------------------------------------------------------------------------

def doLinearFit ( inputListFile, inputJTFile, spectrumID ):

    maxNumIons = 400
    ionCounts = [0]  * maxNumIons
    ionSumP   = [0.] * maxNumIons
    ionSumSqP = [0.] * maxNumIons

    min_numIons =  999
    max_numIons = -999

    min_perIonProb =  999.
    max_perIonProb = -999.

    listFile = file ( inputListFile )
    jtFile = file ( inputJTFile )

    done = 0

    while not done:

  fileName = listFile.readline()
  fileName = fileName[0:len(fileName)-1]
  peptide = getPeptideName ( fileName )

  if ( peptide == '' ): 
      done = 1

  else:

      numIons = Mass.numberIons ( peptide )

      foundSeg = 0
      while not foundSeg:
          aLine = jtFile.readline()
          if ( aLine.startswith('Segment ') ): foundSeg = 1

      i1 = 8
      i2 = aLine.find(' ',8) - 1
      segNumber = int(aLine[i1:i2])

      i1 = aLine.find(')) = ') + 4
      i2 = aLine.find(',', i1)
      totalProb = float(aLine[i1:i2])

      kk = fileName.find ( spectrumID )
      if ( kk > 0 ):
          if ( numIons < maxNumIons ):
              ionCounts[numIons] = ionCounts[numIons] + 1
              ionSumP[numIons] = ionSumP[numIons] + totalProb
              ionSumSqP[numIons] = ionSumSqP[numIons] + ( totalProb * totalProb )
          else:
              print ' error too many ions !!! ', numIons


    listFile.close()
    jtFile.close()

    sumx  = 0.
    sumx2 = 0.
    sumy  = 0.
    sumy2 = 0.
    sumxy = 0.
    num   = 0

    print ' '
    print ' number-of-possible-ions  counts  E[logP]  rms[logP]  sigma[logP] '

    for ii in range(maxNumIons):
  if ( ionCounts[ii] > 0 ):

      # for this # of ions, compute the mean, mean-square and sigma
      # for the probability values found ...
      ionMeanP = ionSumP[ii] / float ( ionCounts[ii] )
      ionMeanSqP = ionSumSqP[ii] / float ( ionCounts[ii] )
      ionSigmaP = sqrt ( ionMeanSqP - ( ionMeanP * ionMeanP ) )
      print ' %3d   %6d   %8.2f   %8.2f   %8.2f ' % ( ii, ionCounts[ii], ionMeanP, sqrt(ionMeanSqP), ionSigmaP )

      # next gather the statistics we need in order to do the
      # linear least-squares regression ... note that we will
      # weight each estimated mean by the # of points that went
      # into estimating it ...
      x = float(ii)
      y = ionMeanP

      sumx  = sumx  + ( float(ionCounts[ii]) * (x) )
      sumx2 = sumx2 + ( float(ionCounts[ii]) * (x*x) )
      sumy  = sumy  + ( float(ionCounts[ii]) * (y) )
      sumy2 = sumy2 + ( float(ionCounts[ii]) * (y*y) )
      sumxy = sumxy + ( float(ionCounts[ii]) * (x*y) )

      num = num + ionCounts[ii]


    expx  = sumx  / float(num)
    expx2 = sumx2 / float(num)
    expy  = sumy  / float(num)
    expy2 = sumy2 / float(num)
    expxy = sumxy / float(num)

    ssxx = sumx2 - ( float(num) * expx * expx )
    ssyy = sumy2 - ( float(num) * expy * expy )
    ssxy = sumxy - ( float(num) * expx * expy )

    # the line is y = a + bx

    b = ssxy / ssxx
    a = expy - ( b * expx )

    r2 = ( ssxy * ssxy ) / ( ssxx * ssyy )

    print ' y-intercept %.4f ' % a
    print ' slope %.4f ' % b
    print ' r2 %.4f ' % r2

    return ( a, b, r2 )


#------------------------------------------------------------------------------
