#!/usr/bin/python
#-----
# $Revision: 1.4 $
#-----
import getopt, sys, copy
from HitGenerator import *
from MatchCollection import *
from MatchGenerator import *
from HitCollection import *
import os
import time

#-------
# Main
#-------
if __name__ == '__main__':
	if len(sys.argv) < 2:
		print """Usage: %s <sqt-filename>  > peptide2spectrum.out

	Given an SQT file, runs DTASelect and prints a list of 
	high-confidence 'peptide - scan number' pairs to STDOUT.
	Also creates a DTASelect directory in the CWD.""" %  \
			(sys.argv[0])
		sys.exit(1)

	dtaHitGen = DtaSelectHitGenerator()
	dtaHitGen["params"] = DtaSelectParams()

	print >>sys.stderr, "Parsing SQT file."
	matchCollection = SqtMatchCollection()
	matchCollection.parseFromFilename(sys.argv[1])
	
	print >>sys.stderr, "Running DTASelect."
	dtaHitCollection = dtaHitGen.generateHits(matchCollection)

	hits = dtaHitCollection.allHits()

	for hit in hits:
		for match in hit["matches"]:
			print match["peptide"], "\t", match["first scan"]


	

	
