#!/usr/bin/python
# $Revision: 1.6 $
import getopt,sys,re,copy,os
from MatchCollection import *
import Mass
import cPickle

if len(sys.argv) < 3:
	print >>sys.stderr, "Usage: %s <sqt-file-1> <pickledpsm-file> <uid to scan> [peps]" % (sys.argv[0])
	sys.exit(1)

usePeps = False
pepsToKeep = {}
if len(sys.argv) > 4:
  usePeps = True
  pepsFile = sys.argv[4]
  print >>sys.stderr, "Parsing peps file"
  for line in open(pepsFile):
    pep = line.rstrip('\n').split('\t')[0]
    pep = re.sub('I','L', pep)
    pepsToKeep[pep] = 1

print >>sys.stderr, "Parsing uid2scan"
scan2uid = {}
fh = open(sys.argv[3])
for line in fh:
  line = line.rstrip('\n')
  uid, scan = line.split()
  scan2uid[int(scan)] = uid
fh.close()

#--------------------------------
print >>sys.stderr, "Parsing SqtMatchCollection"
matches = SqtMatchCollection()
matches.parseFromFilename(sys.argv[1])

print >>sys.stderr, "Parsing pickled psm"
pickledpsm = cPickle.load(open(sys.argv[2]))

curatedPeps = {}
for match in pickledpsm["matches"]:
  peptide = re.sub('I','L', match.peptide)
  uid = match.spectrum.uid()
  curatedPeps[uid] = peptide

list = matches.allMatches()
sqtPeps = {}
for match in list:
  peptide = re.sub('I','L', match["peptide"])
  uid = scan2uid[ int(match["firstScan"]) ] 
  sqtPeps[uid] = peptide

correct = total = 0
for uid in curatedPeps.keys():
  pep = curatedPeps[uid]
  if not sqtPeps.has_key(uid): continue
  if usePeps and not pepsToKeep.has_key(pep): continue
  if sqtPeps[uid] == curatedPeps[uid]:
    correct += 1
  else:
    print "Sequest %s disagrees with real %s for %s" % (sqtPeps[uid], curatedPeps[uid], uid)
  total += 1

print "Accuracy is %i/%i = %.3f" % (correct, total, (correct / float(total)))
