#!/usr/bin/python
#----------------------
# $Revision: 1.7 $
#----------------------
# Description:
# 
#  Given an .ms2 file and a file containing a list of scan charge pairs,
#  extract them from the ms2 file and output them to STDOUT.
#----------------------
import getopt,sys,re,copy,os,os.path
from Utils import *
from SpectrumCollection import *
from Spectrum import *

if __name__ == '__main__':
  if len(sys.argv) < 3:
    print >>sys.stderr, """

Usage: %s <ms2-filename> <scanz-filename> 
  
    <ms2-filename>   - The input .ms2 file.
    <scanz-filename> - File containing scan charge pairs to extract from
                       the .ms2 file (format: scan\\tcharge\\n)

    Writes new ms2 file to STDOUT.
""" % os.path.basename(sys.argv[0])
    sys.exit(1)

  ms2_file = sys.argv[1]
  scan_numbers = sys.argv[2]
  specColl = Ms2SpectrumCollection(ms2_file)
  # for spec in specColl["spectra"]:
  #  print spec.uid()
  
  #print specColl["spectrum dict"]
  #sys.exit(1)

  outSpecColl = Ms2SpectrumCollection()
  outSpecColl["filename"] = "foo"
  prefix = ms2_file.split('.')[0]
  file = open(scan_numbers, 'r')
  for line in file:
    list = line.split()
    if len(list)!=2:
      print >>sys.stderr, "Too many fields!\n"
      sys.exit(1)
    
    # print >>sys.stderr, "Possibly broken method call below"
    spec = specColl.getSpectrum(spectrumUID(list[0],\
      prefix, list[1]))
    if spec != None:
      outSpecColl.appendSpectrum(spec)

  print str(outSpecColl),
