#--------------------------------------------------------
# $Revision: 1.6 $
#--------------------------------------------------------
import getopt, sys

#--------------------------------------------------------
if __name__ == '__main__':
  if len(sys.argv) < 2: 
    print """Usage: python %s 
  <-r train-file> 
  <-t test-file> 
  [-k gaussian|polynomial]
  [-w gaussian width]
  [-d polynomial degree]
  [-m matrix 2 png input]
""" % (sys.argv[0])
    sys.exit(-1)


#--------------------------------------------------------
import cPickle, composite, preproc, time, datafunc, svm, assess, os
import modelSelection
from pylab import *

#--------------------------------------------------------
# Returns prefix to svmFname, rescaleFname 
#--------------------------------------------------------
def main(train=None, test=None,\
    prefix='foo',kernel='polynomial',width=1,degree=2, cvalue=1.0):
  # DataSet = datafunc.SparseCDataSet
  DataSet = datafunc.SparseDataSet
  trainData = DataSet(train, idColumn=0, labelsColumn=1, numericLabels=True) 
  # rs = preproc.Rescale()
  # rs.train(trainData)
  testData = DataSet(test, idColumn=0, labelsColumn=1, numericLabels=True) 
  # rs.test(testData)

  if kernel in ('Polynomial','polynomial','poly'):
    print >>sys.stderr, "Using polynomial kernel of degree %.3f." % degree
    trainData.attachKernel('poly', degree = degree) 
  elif kernel in ('Gaussian','gaussian','rbf'):
    print >>sys.stderr, "Using Gaussian kernel of width %.3f." % width
    trainData.attachKernel('gaussian', gamma = width)
  else:
    print >>sys.stderr, "Using strange kernel"

  s = svm.SVR(C=cvalue)
  #r = s.cv(testData)
  #tp, fp, area = assess.roc(r.Y, r.givenY, r.classify)
  #p = modelSelection.Param(s, 'C', [0.1, 1, 10, 100, 1000])

  #ms = modelSelection.ModelSelector(p)

  #ms.train(trainData)
  #print s.eps
  s.train(trainData)
  r = s.test(testData)
  #for k in range(len(r)):


  k=0
  indicesSortedByRtime = range(len(r[k].patternID))
  indicesSortedByRtime.sort(lambda x,y: cmp(float(r[k].givenY[x]), \
    float(r[k].givenY[y])))
  for out_idx in range(len(r[k].patternID)):
    i = indicesSortedByRtime[out_idx]
    print r[k].patternID[i], r[k].givenY[i], r[k].Y[i]
  hold(False)
  plot(r[k].givenY, r[k].Y, '.')
  savefig(os.path.basename(train) + str(k) + ".png")
  show()
  #print r.givenY
  #print r.Y
  #print r.patternID

  # s.test(trainData)

  # serialize SVM
#  svmFname = prefix + '.svm'
#  svmFh = open(svmFname, 'w')
#  ms.save(svmFh)
#  svmFh.close()
#
#  # serialize rescale
#  rescaleFname = prefix + '.rescale'
#  f = open(rescaleFname, "w")
#  cPickle.dump(rs, f) 
#  f.close()

#  tp, fp, area = assess.roc(r.Y, r.givenY, r.classify)

  #print "Area = ", area

  #return prefix
  
#--------------------------------------------------------
if __name__ == '__main__':
  optlist, args = getopt.getopt(sys.argv[1:],'r:t:k:w:d:c:p:m:')
  train = kernel = width = degree = cvalue = prefix = None
  for option_name,option_value in optlist:
    if option_name == '-r': train=option_value
    if option_name == '-t': test=option_value
    if option_name == '-k': kernel=option_value
    if option_name == '-w': width=float(option_value)
    if option_name == '-d': degree=int(option_value)
    if option_name == '-p': prefix=option_value
    if option_name == '-c': cvalue=float(option_value)

  prefix = main(train=train, test=test, prefix=prefix, kernel=kernel, \
      width=width, degree=degree, cvalue=cvalue)

