#!/usr/bin/python
#-----------------
# $Revision: 1.3 $
#-----------------
import cPickle, re, sys
import compile_aa_stats  
import Spectrum
import SpectrumCollection
import MatchCollection
import Model

#-------
# Main
#-------
if __name__ == '__main__':

  if len(sys.argv) < 3:
    usage = """Usage: %s <gmtk-model-shortname> <gmtk-model> <param-prefix>""" % sys.argv[0]
    raise SystemExit, usage 

  modelName = sys.argv[1]
  gmtkModelName = sys.argv[2]
  paramPrefix   = sys.argv[3]

  if modelName == "GMTK": model = Model.GmtkModel(gmtkModelName, paramPrefix)
  else: raise SystemExit, "Unsupported model %s" % modelName

  print >>sys.stderr, "Training model %s" % modelName
  model.train()

  outFileName = modelName + ".model"
  print >>sys.stderr, "Pickling model to %s"  % outFileName
  outFile = open(outFileName, 'w')
  cPickle.dump(model, outFile)
  outFile.close()
