#---------------------------------------------------------------------------
# File: hmmTrainSion.py
#---------------------------------------------------------------------------
# Author: $Author: aklammer $
#---------------------------------------------------------------------------
# Revision: $Revision: 1.12 $
#---------------------------------------------------------------------------
# hmmTrainSion.py 
#   - <pos-psm-collection> 
#   - <neg-psm-collection> 
#   - <sion-model> 
#   - <integrator-model> 
#   - <param-prefix> 
#---------------------------------------------------------------------------
# Outputs:
#
#---------------------------------------------------------------------------
import os, sys

#-------------------------------------------------------------------------
if __name__ == "__main__":
  if len(sys.argv) < 5:
    print >>sys.stderr, """
Usage: %s 
  <pos-psm-collection> 
  <neg-psm-collection> 
  <cand-psm-collection> 
  <param-prefix>
  <charge>
  """ % os.path.basename(sys.argv[0])
    sys.exit(1)

#-------------------------------------------------------------------------
from hmmParams import *
import random, cPickle, tempfile, shutil, signal
import os
import Mass
import HmmData
import math
import Match
import Spectrum
import Sp
import hmmTestSpectrum 
from GMTK import *
import hmmTrainSion
import GMTKmodel
import FixSvm
import serializeSvmModelSelect


#--------------------------------------
def main(posPsmCollectionName=None, \
      randomPsmCollectionName=None,  \
      candidatePsmCollectionName=None, \
      paramPrefix=None, \
      charge=2):
  singleModel = SINGLE_MODEL_NAME
  pairedModel = PAIR_MODEL_NAME
  singleModelParms = paramPrefix
  pairedModelParms = paramPrefix + "-pair"

  print "Running paired"
  pairedModel = GMTKmodel.gmtkModelFactory(pairedModel, charge=charge, \
      paramPrefix=pairedModelParms)
  pairedSvmOutput = hmmTrainSion.main(posPsmCollectionName=posPsmCollectionName, \
      randomPsmCollectionName=randomPsmCollectionName, \
      candidatePsmCollectionName=candidatePsmCollectionName, \
      model=pairedModel, \
      paramPrefix=pairedModelParms)

  print "Running single %s" % posPsmCollectionName
  singleModel = GMTKmodel.gmtkModelFactory(singleModel, charge=charge, \
      training=True, paramPrefix=singleModelParms)
  singleSvmOutput = hmmTrainSion.main( \
      posPsmCollectionName=posPsmCollectionName, \
      randomPsmCollectionName=randomPsmCollectionName, \
      candidatePsmCollectionName=candidatePsmCollectionName, \
      model=singleModel, \
      paramPrefix=singleModelParms)

  mergedSvmOutput  = "%s.svminput" % paramPrefix
  FixSvm.merge(pairedSvmOutput, singleSvmOutput, mergedSvmOutput)

  svmPrefix = serializeSvmModelSelect.main(train=mergedSvmOutput, \
    prefix=paramPrefix)

  return svmPrefix

#-----------------------------
if __name__ == "__main__":
  
  posPsmCollectionName = sys.argv[1]
  randomPsmCollectionName = sys.argv[2]
  candidatePsmCollectionName = sys.argv[3]
  paramPrefix = sys.argv[4]
  charge = sys.argv[5]
  main(posPsmCollectionName=posPsmCollectionName, \
      randomPsmCollectionName=randomPsmCollectionName,  \
      candidatePsmCollectionName=candidatePsmCollectionName, \
      paramPrefix=paramPrefix, charge=charge)
