#---------------------------------------------------------------------------
# File: hmmTrainSion.py
#---------------------------------------------------------------------------
# Author: $Author: aklammer $
#---------------------------------------------------------------------------
# Revision: $Revision: 1.10 $
#---------------------------------------------------------------------------
# hmmTrainSion.py 
#   - <pos-psm-collection> 
#   - <neg-psm-collection> 
#   - <sion-model> 
#   - <integrator-model> 
#   - <param-prefix> 
#---------------------------------------------------------------------------
import os, sys

#-------------------------------------------------------------------------
if __name__ == "__main__":
  if len(sys.argv) < 4:
    print >>sys.stderr, """
Usage: %s 
  <train-psm-collection> 
  <test-uids>
  <ms2-file-name>
  <fasta-fname>
  <param-prefix> 
  """ % os.path.basename(sys.argv[0])
    sys.exit(1)

#-------------------------------------------------------------------------
from hmmParams import *
import cPickle 
import generatePeptides
import trainMerge
import testSpectraMerge 
import MatchCollection
import Utils

#-------------------------------------------------------------------------
def splitChargePsmCollection(posPsmCollectionName, testSuidsName, paramPrefix):

  posPrefix = os.path.basename(posPsmCollectionName).split('.')[0]
  testPrefix = os.path.basename(testSuidsName).split('.')[0]

  charge2info = {}
  for charge in [ 1, 2, 3 ]:
    thisPrefix = paramPrefix + "+" + str(charge)
    posFile   = "%s+%i.pickledpsm" % (posPrefix, charge)
    testFile  = "%s+%i.suids" % (testPrefix, charge)
    charge2info[charge] = [posFile, testFile, thisPrefix]
  if looksGood(charge2info[3][0]) and looksGood(charge2info[3][1]): 
    return charge2info

  allPos = cPickle.load(open(posPsmCollectionName)) 
  allPos.parsePeaks()
  allTest = map(lambda x: x.rstrip("\n"), open(testSuidsName).readlines())
  for charge in [ 1, 2, 3 ]:
    thisPrefix = paramPrefix + "+" + str(charge)
    posFile   = "%s+%i.pickledpsm" % (posPrefix, charge)
    posPsm = MatchCollection.PsmMatchCollection()
    posPsm["matches"]=filter(lambda x: x.charge == charge, allPos["matches"])
    posFh = open(posFile, "w"); cPickle.dump(posPsm, posFh); posFh.close();
    testFile  = "%s+%i.suids" % (testPrefix, charge)
    fh = open(testFile, "w")
    fh.writelines(filter(lambda x: x.endswith(str(charge)), allTest))
    fh.close()
    charge2info[charge] = [posFile, testFile, thisPrefix]

  return charge2info

#-------------------------------------------------------------------------
if __name__ == "__main__":
  posPsmCollectionName=sys.argv[1]
  testSuidsName=sys.argv[2]
  ms2File =sys.argv[3]
  fastaFname = sys.argv[4]
  paramPrefix=sys.argv[5]

  print >>sys.stderr, "Splitting"
  charge2info = splitChargePsmCollection(\
      posPsmCollectionName, testSuidsName, paramPrefix)

#  print >>sys.stderr, "Training"
#  for charge in charge2info.keys():
#
#    print >>sys.stderr, "Charge +%s" % charge
#    #-----
#    info = charge2info[charge]; posPsmCollectionName = info[0]; 
#    testSuidsName= info[1]; paramPrefix = info[2]
#
#    print >>sys.stderr, "Random"
#    randomPsmCollectionName = generatePeptides.trulyRandomNegative(\
#      fastaFname=fastaFname, spectrumObjectFname=posPsmCollectionName)
#
#    print >>sys.stderr, "Candidate"
#    #----- create the candidate peptide negative psm collection
#    candidatePsmCollectionName = generatePeptides.candidateNegative(\
#        collectionFile=posPsmCollectionName, fastaFname=fastaFname)
#
#    print >>sys.stderr, "Training"
#    #----- train the graphical model
#    svmPrefix = trainMerge.main( \
#      posPsmCollectionName=posPsmCollectionName, \
#      randomPsmCollectionName=randomPsmCollectionName, \
#      candidatePsmCollectionName=candidatePsmCollectionName, \
#      paramPrefix=paramPrefix, charge=charge)
#
#  Utils.alert(subject="Finished training")
  #----- test the charges
  print >>sys.stderr, "Testing"
  for charge in charge2info.keys():
    #-----
    info = charge2info[charge]; 
    testSuidsFilename = info[1]; paramPrefix = info[2]

    #----- test the SVM
    scoreDir = testSpectraMerge.main(suidFile=testSuidsFilename, \
        ms2File=ms2File, fastaFname=fastaFname, paramPrefix=paramPrefix)

    # Utils.alert(subject="Finished testing +%i" % charge)
