#---------------------------------------------------------------------------
# File: hmmTrainSion.py
#---------------------------------------------------------------------------
# Author: $Author: aklammer $
#---------------------------------------------------------------------------
# Revision: $Revision: 1.19 $
#---------------------------------------------------------------------------
# hmmTrainSion.py 
#   - <pos-psm-collection> 
#   - <neg-psm-collection> 
#   - <sion-model> 
#   - <integrator-model> 
#   - <param-prefix> 
#---------------------------------------------------------------------------
import os, sys

#-------------------------------------------------------------------------
if __name__ == "__main__":
  if len(sys.argv) < 5:
    print >>sys.stderr, """
Usage: %s 
  <train-psm-collection> 
  <test-psm-collection>
  <fasta-fname>
  <sion-model> 
  <param-prefix> 
  """ % os.path.basename(sys.argv[0])
    sys.exit(1)

#-------------------------------------------------------------------------
from hmmParams import *
import os.path, random, cPickle, tempfile, shutil, signal
import generatePeptides, spFilter, hmmTrainSion
import serializeSvmModelSelect, hmmTestSpectraSion, hmmAccuracySionSvm
import serializeSvm
import GMTKmodel

#-------------------------------------------------------------------------
if __name__ == "__main__":
  posPsmCollectionName=sys.argv[1]
  testPsmCollectionName=sys.argv[2]
  fastaFname = sys.argv[3]
  sionModel=sys.argv[4]
  paramPrefix=sys.argv[5]

  model = GMTKmodel.gmtkModelFactory(sionModel)

  randomPsmCollectionName = generatePeptides.trulyRandomNegative(\
    fastaFname=fastaFname, spectrumObjectFname=posPsmCollectionName)

  #----- create the candidate peptide negative psm collection
  candidatePsmCollectionName = generatePeptides.candidateNegative(\
      collectionFile=posPsmCollectionName, fastaFname=fastaFname)

  #----- train the graphical model
  svmInputFname = hmmTrainSion.main(posPsmCollectionName=posPsmCollectionName, \
    randomPsmCollectionName=randomPsmCollectionName, \
    candidatePsmCollectionName=candidatePsmCollectionName, \
    model=model, paramPrefix=paramPrefix)

  #----- train the SVM
  svmPrefix = serializeSvmModelSelect.main(train=svmInputFname, \
    prefix=paramPrefix)
  #svmPrefix  = serializeSvm.main(train=svmInputFname, \
  #  prefix=paramPrefix, kernel='polynomial', degree = 1, )

  #----- test the SVM
  scoreDir = hmmTestSpectraSion.main(collectionFile=testPsmCollectionName, \
    fastaFname=fastaFname, model=model, gmtkParms=paramPrefix, \
    svmPrefix=svmPrefix, null='F')
  scoreDir = hmmTestSpectraSion.main(collectionFile=testPsmCollectionName, \
    fastaFname=fastaFname, model=model, gmtkParms=paramPrefix, \
    svmPrefix=svmPrefix, null='T')
