# returns full, partial or not
def trypticity(peptide, left="R", right="-", missedCleavagesAllowed=100):
  rightTryptic = leftTryptic = False
  # the left side
  if (left in ['R', 'K'] and peptide[0] != 'P') or left == '-': 
    leftTryptic = True

  # the right side
  if (peptide[-1] in ['R', 'K'] and right != 'P') or right == '-':
    rightTryptic = True

  # the missed cleavages
  missedCleavages = 0
  for idx in range(len(peptide)-1):
    if peptide[idx] in ['R', 'K'] and peptide[idx+1] != 'P':
      missedCleavages += 1

  if rightTryptic and leftTryptic \
      and missedCleavages <= missedCleavagesAllowed:
    return 'tryptic'
  elif (rightTryptic or leftTryptic) \
      and missedCleavages <= missedCleavagesAllowed:
    return 'partial'
  else:
    return 'not'

def isTryptic(peptide,missedCleavagesAllowed=100):
  if trypticity(peptide, missedCleavagesAllowed=missedCleavagesAllowed) == 'tryptic': return True
  else: return False

if __name__ == '__main__':

  print 'K.EAMAPK.E = ',
  print trypticity('EAMAPK', left='K', right='E')

  print 'K.FKVEVIAGLK.R',
  print trypticity('FKVEVIAGLK', left='K', right='R')

  print 'K.EAMAPK.P = ',
  print trypticity('EAMAPK', left='K', right='P')

  print 'K.PAMAPK.P = ',
  print trypticity('PAMAPK', left='K', right='P')

  print 'K.EAMAPK.E mc0 = ',
  print trypticity('EAMAPK', left='K', right='E', missedCleavagesAllowed = 0)

  print 'K.EAKMAPK.E mc0 = ',
  print trypticity('EAKMAPK', left='K', right='E', missedCleavagesAllowed = 0)

  print 'K.EAKMAPK.E mc1 = ',
  print trypticity('EAKMAPK', left='K', right='E', missedCleavagesAllowed = 1)
  
  print 'R.IAAQTLEEDE.- = ',
  print trypticity('IAAQTLEEDE', left='R', right='-')
